/* Generated by re2c 0.12.3 on Sat Aug 15 14:16:47 2009 */
#line 1 "./json.re"
/*
 * json.re
 *
 * JSON Lexer based on re2c
 *
 * Ulrik Sandborg-Petersen
 * Created: 7/28-2008
 * Last update: 7/28-2008
 *
 */
/************************************************************************
 *
 *   Emdros - the database engine for analyzed or annotated text
 *   Copyright (C) 2008  Ulrik Sandborg-Petersen
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation, license version 2.  
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *   02111-1307 USA
 *
 *
 *   Special exception
 *   =================
 * 
 *   In addition, as a special exception, Ulrik Petersen, the
 *   copyright holder of Emdros, gives permission to link Emdros, in
 *   whole or in part, with the libraries which are normally
 *   distributed with:
 *   
 *   a) Sun's Java platform,
 *   b) Python, 
 *   c) Jython,
 *   d) Ruby, and/or 
 *   e) Perl 
 *   f) PostgreSQL
 *   g) OpenSSL
 *
 *   (or with modified versions of these), and to distribute linked
 *   combinations including both Emdros, in whole or in part, and one
 *   or more of the libraries normally distributed with (a)-(g) above.
 *
 *   Please note: This gives you special rights concerning the
 *   libraries which normally accompany the above pieces of software.
 *   It gives you no special rights concerning software that you write
 *   yourself.  You must obey the GNU General Public License in all
 *   respects for all of the code used other than the libraries
 *   normally distributed with (a)-(g) above.
 *
 *   If you modify this file, you may extend this exception to your
 *   version of the file, but you are not obligated to do so. If you
 *   do not wish to do so, delete this exception statement from your
 *   version.
 *
 *
 *   Other licensing forms
 *   =====================
 *
 *   If you wish to negotiate commercial licensing, please contact
 *   Ulrik Petersen at ulrikp[at]users.sourceforge.net.
 *
 *   Licensing can also be negotiated if your organization is an
 *   educational, non-profit, charity, missionary or similar
 *   organization.
 *
 *
 *   Website
 *   =======
 *
 *   Emdros has a website here:
 *
 *   http://emdros.org
 *
 *
 *
 **************************************************************************/

#include <json_lexer.h>
#include "jsonpars.h"
#include <iostream>
#include <string_func.h>

#define YYCTYPE         unsigned char
#define YYCURSOR        cur
#define YYLIMIT         lim
#define YYMARKER        ptr
#line 98 "./json.re"



#line 133 "./json.re"



JSONScanner::JSONScanner(const std::string& strIn)
{
	sz = strIn.c_str();
	lim = sz + strIn.length();
	bot = tok = ptr = pos = top = eof = 0;
	cur = sz;
}

JSONScanner::~JSONScanner()
{
	if (bot) {
		delete[] bot;
	}
}

/*
char *JSONScanner::fill(char *cursor)
{
        if(!eof)
        {
                unsigned int cnt = tok - bot;
                if(cnt)
                {
                        memcpy(bot, tok, lim - tok);
                        tok = bot;
                        ptr -= cnt;
                        cursor -= cnt;
                        pos -= cnt;
                        lim -= cnt;
                }
                if((top - lim) < BSIZE)
                {
                        char *buf = new char[(lim - bot) + BSIZE];
                        memcpy(buf, tok, lim - tok);
                        tok = buf;
                        ptr = &buf[ptr - bot];
                        cursor = &buf[cursor - bot];
                        pos = &buf[pos - bot];
                        lim = &buf[lim - bot];
                        top = &lim[BSIZE];
                        delete [] bot;
                        bot = buf;
                }
                pIn->read(lim, BSIZE);
                if ((cnt = pIn->gcount()) != BSIZE )
                {
                        eof = &lim[cnt]; *eof++ = '\0';
                }
                lim += cnt;
        }
        return cursor;
}
*/

#define TOKEN_RETURN(X,Y) { yylval->setName(X); return Y; }

int JSONScanner::scan(Token *pYYLVAL)
{
	yylval = pYYLVAL;

 scan:	
	tok = cur;


#line 170 "./json_lexer.cpp"
{
	YYCTYPE yych;

	yych = *YYCURSOR;
	if(yych <= 'M') {
		if(yych <= '!') {
			if(yych <= 0x0A) {
				if(yych <= 0x00) goto jj30;
				if(yych <= 0x08) goto jj32;
				if(yych <= 0x09) goto jj24;
				goto jj28;
			} else {
				if(yych <= 0x0D) {
					if(yych <= 0x0C) goto jj32;
					goto jj26;
				} else {
					if(yych == ' ') goto jj22;
					goto jj32;
				}
			}
		} else {
			if(yych <= '/') {
				if(yych <= '"') goto jj20;
				if(yych == ',') goto jj16;
				goto jj32;
			} else {
				if(yych <= ':') {
					if(yych <= '9') goto jj18;
					goto jj14;
				} else {
					if(yych != 'F') goto jj32;
				}
			}
		}
	} else {
		if(yych <= 'f') {
			if(yych <= 'Z') {
				if(yych <= 'N') goto jj5;
				if(yych == 'T') goto jj4;
				goto jj32;
			} else {
				if(yych <= '\\') {
					if(yych <= '[') goto jj10;
					goto jj32;
				} else {
					if(yych <= ']') goto jj12;
					if(yych <= 'e') goto jj32;
				}
			}
		} else {
			if(yych <= 't') {
				if(yych == 'n') goto jj5;
				if(yych <= 's') goto jj32;
				goto jj4;
			} else {
				if(yych <= '{') {
					if(yych <= 'z') goto jj32;
					goto jj6;
				} else {
					if(yych == '}') goto jj8;
					goto jj32;
				}
			}
		}
	}
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'A') goto jj51;
	if(yych == 'a') goto jj51;
jj3:
#line 219 "./json.re"
	{ yylval->setChar(*tok);
	    TOKEN_RETURN(CHAR_MAGIC, *tok); }
#line 243 "./json_lexer.cpp"
jj4:
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'R') goto jj47;
	if(yych == 'r') goto jj47;
	goto jj3;
jj5:
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'U') goto jj42;
	if(yych == 'u') goto jj42;
	goto jj3;
jj6:
	++YYCURSOR;
#line 203 "./json.re"
	{ TOKEN_RETURN("{", T_KEY_BRACE_OPEN); }
#line 258 "./json_lexer.cpp"
jj8:
	++YYCURSOR;
#line 204 "./json.re"
	{ TOKEN_RETURN("}", T_KEY_BRACE_CLOSE); }
#line 263 "./json_lexer.cpp"
jj10:
	++YYCURSOR;
#line 205 "./json.re"
	{ TOKEN_RETURN("[", T_KEY_BRACKET_OPEN); }
#line 268 "./json_lexer.cpp"
jj12:
	++YYCURSOR;
#line 206 "./json.re"
	{ TOKEN_RETURN("]", T_KEY_BRACKET_CLOSE); }
#line 273 "./json_lexer.cpp"
jj14:
	++YYCURSOR;
#line 207 "./json.re"
	{ TOKEN_RETURN(":", T_KEY_COLON);  }
#line 278 "./json_lexer.cpp"
jj16:
	++YYCURSOR;
#line 208 "./json.re"
	{ TOKEN_RETURN(",", T_KEY_COMMA);  }
#line 283 "./json_lexer.cpp"
jj18:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '/') goto jj19;
	if(yych <= '9') goto jj33;
jj19:
#line 209 "./json.re"
	{ addInteger();
                              TOKEN_RETURN(INTEGER_MAGIC, T_INTEGER); }
#line 292 "./json_lexer.cpp"
jj20:
	++YYCURSOR;
#line 211 "./json.re"
	{ yylval->setString(new std::string);
			      goto stringdq; 
                            }
#line 299 "./json_lexer.cpp"
jj22:
	++YYCURSOR;
#line 214 "./json.re"
	{ goto scan; }
#line 304 "./json_lexer.cpp"
jj24:
	++YYCURSOR;
#line 215 "./json.re"
	{ goto scan; }
#line 309 "./json_lexer.cpp"
jj26:
	++YYCURSOR;
#line 216 "./json.re"
	{ goto scan; }
#line 314 "./json_lexer.cpp"
jj28:
	++YYCURSOR;
#line 217 "./json.re"
	{ goto scan; }
#line 319 "./json_lexer.cpp"
jj30:
	++YYCURSOR;
#line 218 "./json.re"
	{ if (cur >= lim) { goto end; } }
#line 324 "./json_lexer.cpp"
jj32:
	yych = *++YYCURSOR;
	goto jj3;
jj33:
	yych = *++YYCURSOR;
	if(yych <= '/') goto jj19;
	if(yych >= ':') goto jj19;
	yych = *++YYCURSOR;
	if(yych <= '/') goto jj19;
	if(yych >= ':') goto jj19;
	yych = *++YYCURSOR;
	if(yych <= '/') goto jj19;
	if(yych >= ':') goto jj19;
	yych = *++YYCURSOR;
	if(yych <= '/') goto jj19;
	if(yych >= ':') goto jj19;
	yych = *++YYCURSOR;
	if(yych <= '/') goto jj19;
	if(yych >= ':') goto jj19;
	yych = *++YYCURSOR;
	if(yych <= '/') goto jj19;
	if(yych >= ':') goto jj19;
	yych = *++YYCURSOR;
	if(yych <= '/') goto jj19;
	if(yych >= ':') goto jj19;
	yych = *++YYCURSOR;
	if(yych <= '/') goto jj19;
	if(yych >= ':') goto jj19;
	yych = *++YYCURSOR;
	goto jj19;
jj42:
	yych = *++YYCURSOR;
	if(yych == 'L') goto jj44;
	if(yych == 'l') goto jj44;
jj43:
	YYCURSOR = YYMARKER;
	goto jj3;
jj44:
	yych = *++YYCURSOR;
	if(yych == 'L') goto jj45;
	if(yych != 'l') goto jj43;
jj45:
	++YYCURSOR;
#line 202 "./json.re"
	{ TOKEN_RETURN("null", T_KEY_NULL); }
#line 370 "./json_lexer.cpp"
jj47:
	yych = *++YYCURSOR;
	if(yych == 'U') goto jj48;
	if(yych != 'u') goto jj43;
jj48:
	yych = *++YYCURSOR;
	if(yych == 'E') goto jj49;
	if(yych != 'e') goto jj43;
jj49:
	++YYCURSOR;
#line 201 "./json.re"
	{ TOKEN_RETURN("true", T_KEY_TRUE); }
#line 383 "./json_lexer.cpp"
jj51:
	yych = *++YYCURSOR;
	if(yych == 'L') goto jj52;
	if(yych != 'l') goto jj43;
jj52:
	yych = *++YYCURSOR;
	if(yych == 'S') goto jj53;
	if(yych != 's') goto jj43;
jj53:
	yych = *++YYCURSOR;
	if(yych == 'E') goto jj54;
	if(yych != 'e') goto jj43;
jj54:
	++YYCURSOR;
#line 200 "./json.re"
	{ TOKEN_RETURN("false", T_KEY_FALSE); }
#line 400 "./json_lexer.cpp"
}
#line 221 "./json.re"


stringdq:
	tok = cur;

#line 408 "./json_lexer.cpp"
{
	YYCTYPE yych;
	yych = *YYCURSOR;
	if(yych <= '!') {
		if(yych <= 0x00) goto jj62;
		if(yych == 0x0A) goto jj65;
		goto jj64;
	} else {
		if(yych <= '"') goto jj58;
		if(yych == '\\') goto jj60;
		goto jj64;
	}
jj58:
	++YYCURSOR;
#line 226 "./json.re"
	{ TOKEN_RETURN("string", T_STRING); }
#line 425 "./json_lexer.cpp"
jj60:
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'b') {
		if(yych <= '>') {
			if(yych <= '"') {
				if(yych >= '"') goto jj69;
			} else {
				if(yych == '\'') goto jj71;
			}
		} else {
			if(yych <= '[') {
				if(yych <= '?') goto jj73;
			} else {
				if(yych <= '\\') goto jj75;
				if(yych >= 'b') goto jj81;
			}
		}
	} else {
		if(yych <= 'q') {
			if(yych <= 'f') {
				if(yych >= 'f') goto jj77;
			} else {
				if(yych == 'n') goto jj85;
			}
		} else {
			if(yych <= 't') {
				if(yych <= 'r') goto jj79;
				if(yych >= 't') goto jj83;
			} else {
				if(yych == 'x') goto jj67;
			}
		}
	}
jj61:
#line 243 "./json.re"
	{ yylval->pString->append(1, *tok);
			       goto stringdq; }
#line 463 "./json_lexer.cpp"
jj62:
	++YYCURSOR;
#line 242 "./json.re"
	{ if (cur >= lim) { goto end; } }
#line 468 "./json_lexer.cpp"
jj64:
	yych = *++YYCURSOR;
	goto jj61;
jj65:
	++YYCURSOR;
#line 245 "./json.re"
	{ yylval->pString->append(1, '\n');
			       goto stringdq; }
#line 477 "./json_lexer.cpp"
jj67:
	yych = *++YYCURSOR;
	if(yych <= '@') {
		if(yych <= '/') goto jj68;
		if(yych <= '9') goto jj87;
	} else {
		if(yych <= 'F') goto jj87;
		if(yych <= '`') goto jj68;
		if(yych <= 'f') goto jj87;
	}
jj68:
	YYCURSOR = YYMARKER;
	goto jj61;
jj69:
	++YYCURSOR;
#line 235 "./json.re"
	{ yylval->pString->append(1, '\"'); goto stringdq; }
#line 495 "./json_lexer.cpp"
jj71:
	++YYCURSOR;
#line 234 "./json.re"
	{ yylval->pString->append(1, '\''); goto stringdq; }
#line 500 "./json_lexer.cpp"
jj73:
	++YYCURSOR;
#line 233 "./json.re"
	{ yylval->pString->append(1, '\?'); goto stringdq; }
#line 505 "./json_lexer.cpp"
jj75:
	++YYCURSOR;
#line 232 "./json.re"
	{ yylval->pString->append(1, '\\'); goto stringdq; }
#line 510 "./json_lexer.cpp"
jj77:
	++YYCURSOR;
#line 231 "./json.re"
	{ yylval->pString->append(1, '\f'); goto stringdq; }
#line 515 "./json_lexer.cpp"
jj79:
	++YYCURSOR;
#line 230 "./json.re"
	{ yylval->pString->append(1, '\r'); goto stringdq; }
#line 520 "./json_lexer.cpp"
jj81:
	++YYCURSOR;
#line 229 "./json.re"
	{ yylval->pString->append(1, '\b'); goto stringdq; }
#line 525 "./json_lexer.cpp"
jj83:
	++YYCURSOR;
#line 228 "./json.re"
	{ yylval->pString->append(1, '\t'); goto stringdq; }
#line 530 "./json_lexer.cpp"
jj85:
	++YYCURSOR;
#line 227 "./json.re"
	{ yylval->pString->append(1, '\n'); goto stringdq; }
#line 535 "./json_lexer.cpp"
jj87:
	yych = *++YYCURSOR;
	if(yych <= '@') {
		if(yych <= '/') goto jj68;
		if(yych >= ':') goto jj68;
	} else {
		if(yych <= 'F') goto jj88;
		if(yych <= '`') goto jj68;
		if(yych >= 'g') goto jj68;
	}
jj88:
	++YYCURSOR;
#line 236 "./json.re"
	{ tok += 2; // Go past SLASH x
			       std::string mystr;
			       getString(mystr);
			       yylval->pString->append(1, hex2char(mystr.c_str()));
			       goto stringdq; 			     
                             }
#line 555 "./json_lexer.cpp"
}
#line 247 "./json.re"


 end:
	return 0;
}


void JSONScanner::addToken(void)
{
	yylval->setString(new std::string);
	const char *p;
	for (p = tok;
	     p != cur;
	     ++p) {
	     yylval->pString->append(1, *p);
	}
}

void JSONScanner::addInteger(void)
{
	const unsigned int MAX_INTEGER_CHARS = 12;
	unsigned int cnt = cur - tok;
	if (cnt > MAX_INTEGER_CHARS) {
	   	std::string mystring;
		const char *p;
		for (p = tok;
		     p != cur;
	     	     ++p) {
		     mystring.append(1, *p);
		}
		yylval->setInteger(strtol(mystring.c_str(), (char **)NULL, 10));
        } else {
		char szInt[MAX_INTEGER_CHARS+1];

		const char *p;
		char *q = szInt;
		for (p = tok;
		     p != cur;
	     	     ++p) {
		     *q++ = *p;
		}
		*q = '\0';
		yylval->setInteger(strtol(szInt, (char **)NULL, 10));
	}
}

void JSONScanner::getString(std::string& str)
{
	const char *p;
	for (p = tok;
	     p != cur;
	     ++p) {
	     str.append(1, *p);
	}
}

