/* Generated by re2c 0.12.3 on Sat Aug 15 14:16:47 2009 */
#line 1 "./mql_gq.re"
/*
 * mql_gq.cpp
 *
 * MQL "Get Query from stream" scanner
 *
 * Ulrik Petersen
 * Created: 6/23-2007
 * Last update: 6/23-2007
 *
 */
/************************************************************************
 *
 *   Emdros - the database engine for analyzed or annotated text
 *   Copyright (C) 2001-2007  Ulrik Petersen
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation, license version 2.  
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *   02111-1307 USA
 *
 *
 *   Special exception
 *   =================
 * 
 *   In addition, as a special exception, Ulrik Petersen, the
 *   copyright holder of Emdros, gives permission to link Emdros, in
 *   whole or in part, with the libraries which are normally
 *   distributed with:
 *   
 *   a) Sun's Java platform,
 *   b) Python, 
 *   c) Jython,
 *   d) Ruby, and/or 
 *   e) Perl 
 *   f) PostgreSQL
 *   g) OpenSSL
 *
 *   (or with modified versions of these), and to distribute linked
 *   combinations including both Emdros, in whole or in part, and one
 *   or more of the libraries normally distributed with (a)-(g) above.
 *
 *   Please note: This gives you special rights concerning the
 *   libraries which normally accompany the above pieces of software.
 *   It gives you no special rights concerning software that you write
 *   yourself.  You must obey the GNU General Public License in all
 *   respects for all of the code used other than the libraries
 *   normally distributed with (a)-(g) above.
 *
 *   If you modify this file, you may extend this exception to your
 *   version of the file, but you are not obligated to do so. If you
 *   do not wish to do so, delete this exception statement from your
 *   version.
 *
 *
 *   Other licensing forms
 *   =====================
 *
 *   If you wish to negotiate commercial licensing, please contact
 *   Ulrik Petersen at ulrikp[at]users.sourceforge.net.
 *
 *   Licensing can also be negotiated if your organization is an
 *   educational, non-profit, charity, missionary or similar
 *   organization.
 *
 *
 *   Website
 *   =======
 *
 *   Emdros has a website here:
 *
 *   http://emdros.org
 *
 *
 *
 **************************************************************************/

/**@file mql_gq.re
 *@brief Implementation of MQLGQScanner (re-based) (MQL layer)
 */


#include <cstring>
#include <mql_gq.h>

#define BSIZE (1024*1024)

#define YYCTYPE         unsigned char
#define YYCURSOR        cursor
#define YYLIMIT         lim
#define YYMARKER        ptr
#define YYFILL(n)       {cursor = fill(cursor);}

#line 111 "./mql_gq.re"



MQLGQScanner::MQLGQScanner(std::istream *pIstr)
{
	pIn = pIstr;
	pBigstring = 0;
	bot = tok = ptr = cur = pos = lim = top = eof = 0;
}

MQLGQScanner::~MQLGQScanner()
{
	delete pBigstring;
	if (bot) {
		delete[] bot;
	}
}

void MQLGQScanner::addToken(void)
{
	char *p;
	for (p = tok;
	     p != cur;
	     ++p) {
		pBigstring->addChar(*p);
	}
}

char *MQLGQScanner::fill(char *cursor)
{
        if(!eof)
        {
                unsigned int cnt = tok - bot;
                if(cnt)
                {
                        memcpy(bot, tok, lim - tok);
                        tok = bot;
                        ptr -= cnt;
                        cursor -= cnt;
                        pos -= cnt;
                        lim -= cnt;
                }
                if((top - lim) < BSIZE)
                {
                        char *buf = new char[(lim - bot) + BSIZE];
                        memcpy(buf, tok, lim - tok);
                        tok = buf;
                        ptr = &buf[ptr - bot];
                        cursor = &buf[cursor - bot];
                        pos = &buf[pos - bot];
                        lim = &buf[lim - bot];
                        top = &lim[BSIZE];
                        delete [] bot;
                        bot = buf;
                }
                pIn->read(lim, BSIZE);
                if ((cnt = pIn->gcount()) != BSIZE )
                {
                        eof = &lim[cnt]; *eof++ = '\0';
                }
                lim += cnt;
        }
        return cursor;
}


Bigstring *MQLGQScanner::scan(void)
{
	pBigstring = new Bigstring();
	char *cursor = cur;

 scan:	
	tok = cursor;


#line 180 "./mql_get_query.cpp"
{
	YYCTYPE yych;

	if((YYLIMIT - YYCURSOR) < 5) YYFILL(5);
	yych = *YYCURSOR;
	if(yych <= 'G') {
		if(yych <= '&') {
			if(yych <= 0x0A) {
				if(yych <= 0x00) goto yy12;
				if(yych <= 0x09) goto yy16;
				goto yy14;
			} else {
				if(yych == '"') goto yy8;
				goto yy16;
			}
		} else {
			if(yych <= '/') {
				if(yych <= '\'') goto yy10;
				if(yych <= '.') goto yy16;
				goto yy6;
			} else {
				if(yych <= '@') goto yy16;
				if(yych <= 'F') goto yy5;
				goto yy4;
			}
		}
	} else {
		if(yych <= '`') {
			if(yych <= 'Z') {
				if(yych != 'Q') goto yy5;
			} else {
				if(yych == '_') goto yy5;
				goto yy16;
			}
		} else {
			if(yych <= 'p') {
				if(yych == 'g') goto yy4;
				goto yy5;
			} else {
				if(yych <= 'q') goto yy2;
				if(yych <= 'z') goto yy5;
				goto yy16;
			}
		}
	}
yy2:
	++YYCURSOR;
	if((yych = *YYCURSOR) == 'U') goto yy25;
	if(yych == 'u') goto yy25;
	goto yy22;
yy3:
#line 188 "./mql_gq.re"
	{ cur = cursor; addToken(); goto scan; }
#line 234 "./mql_get_query.cpp"
yy4:
	yych = *++YYCURSOR;
	if(yych == 'O') goto yy23;
	if(yych == 'o') goto yy23;
	goto yy22;
yy5:
	yych = *++YYCURSOR;
	goto yy22;
yy6:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '*') goto yy19;
	if(yych == '/') goto yy17;
yy7:
#line 201 "./mql_gq.re"
	{ pBigstring->addChar(*tok); goto scan; }
#line 250 "./mql_get_query.cpp"
yy8:
	++YYCURSOR;
#line 191 "./mql_gq.re"
	{ pBigstring->addChar('\"');
	    cur = cursor;
	    goto stringdq;
          }
#line 258 "./mql_get_query.cpp"
yy10:
	++YYCURSOR;
#line 195 "./mql_gq.re"
	{ pBigstring->addChar('\'');
	    cur = cursor;
	    goto stringsq;
          }
#line 266 "./mql_get_query.cpp"
yy12:
	++YYCURSOR;
#line 199 "./mql_gq.re"
	{ if (cursor == eof) { cur = cursor; goto end; } }
#line 271 "./mql_get_query.cpp"
yy14:
	++YYCURSOR;
#line 200 "./mql_gq.re"
	{ pBigstring->addChar('\n'); goto scan; }
#line 276 "./mql_get_query.cpp"
yy16:
	yych = *++YYCURSOR;
	goto yy7;
yy17:
	++YYCURSOR;
#line 190 "./mql_gq.re"
	{ goto cppcomment; }
#line 284 "./mql_get_query.cpp"
yy19:
	++YYCURSOR;
#line 189 "./mql_gq.re"
	{ goto comment; }
#line 289 "./mql_get_query.cpp"
yy21:
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy22:
	if(yych <= 'Z') {
		if(yych <= '/') goto yy3;
		if(yych <= '9') goto yy21;
		if(yych <= '@') goto yy3;
		goto yy21;
	} else {
		if(yych <= '_') {
			if(yych <= '^') goto yy3;
			goto yy21;
		} else {
			if(yych <= '`') goto yy3;
			if(yych <= 'z') goto yy21;
			goto yy3;
		}
	}
yy23:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto yy24;
		if(yych <= '9') goto yy21;
		if(yych >= 'A') goto yy21;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto yy21;
		} else {
			if(yych <= '`') goto yy24;
			if(yych <= 'z') goto yy21;
		}
	}
yy24:
#line 187 "./mql_gq.re"
	{ cur = cursor; /* addToken(); */ tok = cur; goto end; }
#line 327 "./mql_get_query.cpp"
yy25:
	yych = *++YYCURSOR;
	if(yych == 'I') goto yy26;
	if(yych != 'i') goto yy22;
yy26:
	yych = *++YYCURSOR;
	if(yych == 'T') goto yy27;
	if(yych != 't') goto yy22;
yy27:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto yy28;
		if(yych <= '9') goto yy21;
		if(yych >= 'A') goto yy21;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto yy21;
		} else {
			if(yych <= '`') goto yy28;
			if(yych <= 'z') goto yy21;
		}
	}
yy28:
#line 186 "./mql_gq.re"
	{ cur = cursor; addToken(); pBigstring->addsz(" GO"); tok = cur; goto end; }
#line 353 "./mql_get_query.cpp"
}
#line 202 "./mql_gq.re"


 comment:
        tok = cursor;

#line 361 "./mql_get_query.cpp"
{
	YYCTYPE yych;
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= 0x0A) {
		if(yych <= 0x00) goto yy35;
		if(yych <= 0x09) goto yy37;
		goto yy33;
	} else {
		if(yych != '*') goto yy37;
	}
	++YYCURSOR;
	if((yych = *YYCURSOR) == '/') goto yy38;
yy32:
#line 210 "./mql_gq.re"
	{ tok = cur; goto comment; }
#line 378 "./mql_get_query.cpp"
yy33:
	++YYCURSOR;
#line 208 "./mql_gq.re"
	{ pBigstring->addChar('\n'); goto comment; }
#line 383 "./mql_get_query.cpp"
yy35:
	++YYCURSOR;
#line 209 "./mql_gq.re"
	{ if (cursor == eof) { goto end; } }
#line 388 "./mql_get_query.cpp"
yy37:
	yych = *++YYCURSOR;
	goto yy32;
yy38:
	++YYCURSOR;
#line 207 "./mql_gq.re"
	{  goto scan; }
#line 396 "./mql_get_query.cpp"
}
#line 211 "./mql_gq.re"


 cppcomment:
        tok = cursor;

#line 404 "./mql_get_query.cpp"
{
	YYCTYPE yych;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= 0x00) goto yy44;
	if(yych != 0x0A) goto yy46;
	++YYCURSOR;
#line 216 "./mql_gq.re"
	{ pBigstring->addChar('\n'); goto scan; }
#line 414 "./mql_get_query.cpp"
yy44:
	++YYCURSOR;
#line 217 "./mql_gq.re"
	{ if (cursor == eof) { goto end; } }
#line 419 "./mql_get_query.cpp"
yy46:
	++YYCURSOR;
#line 218 "./mql_gq.re"
	{ tok = cur; goto cppcomment; }
#line 424 "./mql_get_query.cpp"
}
#line 219 "./mql_gq.re"


stringdq:
	tok = cursor;

#line 432 "./mql_get_query.cpp"
{
	YYCTYPE yych;
	if((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if(yych <= '!') {
		if(yych <= 0x00) goto yy56;
		if(yych == 0x0A) goto yy54;
		goto yy58;
	} else {
		if(yych <= '"') goto yy50;
		if(yych == '\\') goto yy52;
		goto yy58;
	}
yy50:
	++YYCURSOR;
#line 224 "./mql_gq.re"
	{ pBigstring->addChar(*tok);
  	        cur = cursor;
	        goto scan;
              }
#line 453 "./mql_get_query.cpp"
yy52:
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'b') {
		if(yych <= '3') {
			if(yych <= '&') {
				if(yych == '"') goto yy62;
			} else {
				if(yych <= '\'') goto yy62;
				if(yych >= '0') goto yy61;
			}
		} else {
			if(yych <= '[') {
				if(yych == '?') goto yy62;
			} else {
				if(yych <= '\\') goto yy62;
				if(yych >= 'a') goto yy62;
			}
		}
	} else {
		if(yych <= 'r') {
			if(yych <= 'm') {
				if(yych == 'f') goto yy62;
			} else {
				if(yych <= 'n') goto yy62;
				if(yych >= 'r') goto yy62;
			}
		} else {
			if(yych <= 'u') {
				if(yych == 't') goto yy62;
			} else {
				if(yych <= 'v') goto yy62;
				if(yych == 'x') goto yy59;
			}
		}
	}
yy53:
#line 242 "./mql_gq.re"
	{ pBigstring->addChar(*tok); cur = cursor; goto stringdq; }
#line 492 "./mql_get_query.cpp"
yy54:
	++YYCURSOR;
#line 240 "./mql_gq.re"
	{ pBigstring->addChar('\n'); cur = cursor; goto stringdq; }
#line 497 "./mql_get_query.cpp"
yy56:
	++YYCURSOR;
#line 241 "./mql_gq.re"
	{ if (cursor == eof) { goto end; } }
#line 502 "./mql_get_query.cpp"
yy58:
	yych = *++YYCURSOR;
	goto yy53;
yy59:
	yych = *++YYCURSOR;
	if(yych <= '@') {
		if(yych <= '/') goto yy60;
		if(yych <= '9') goto yy67;
	} else {
		if(yych <= 'F') goto yy67;
		if(yych <= '`') goto yy60;
		if(yych <= 'f') goto yy67;
	}
yy60:
	YYCURSOR = YYMARKER;
	goto yy53;
yy61:
	yych = *++YYCURSOR;
	if(yych <= '/') goto yy60;
	if(yych <= '7') goto yy64;
	goto yy60;
yy62:
	++YYCURSOR;
#line 228 "./mql_gq.re"
	{ cur = cursor; 
		      addToken();
		      goto stringdq;
                    }
#line 531 "./mql_get_query.cpp"
yy64:
	yych = *++YYCURSOR;
	if(yych <= '/') goto yy60;
	if(yych >= '8') goto yy60;
	++YYCURSOR;
#line 232 "./mql_gq.re"
	{ cur = cursor; 
		    addToken();
		    goto stringdq; 
                  }
#line 542 "./mql_get_query.cpp"
yy67:
	yych = *++YYCURSOR;
	if(yych <= '@') {
		if(yych <= '/') goto yy60;
		if(yych >= ':') goto yy60;
	} else {
		if(yych <= 'F') goto yy68;
		if(yych <= '`') goto yy60;
		if(yych >= 'g') goto yy60;
	}
yy68:
	++YYCURSOR;
#line 236 "./mql_gq.re"
	{ cur = cursor;
			       addToken();
			       goto stringdq;
                             }
#line 560 "./mql_get_query.cpp"
}
#line 243 "./mql_gq.re"


stringsq:
	tok = cursor;

#line 568 "./mql_get_query.cpp"
{
	YYCTYPE yych;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= 0x0A) {
		if(yych <= 0x00) goto yy76;
		if(yych <= 0x09) goto yy78;
		goto yy74;
	} else {
		if(yych != '\'') goto yy78;
	}
	++YYCURSOR;
#line 248 "./mql_gq.re"
	{ pBigstring->addChar('\'');
  	        cur = cursor;
	        goto scan;
              }
#line 586 "./mql_get_query.cpp"
yy74:
	++YYCURSOR;
#line 252 "./mql_gq.re"
	{ pBigstring->addChar('\n'); cur = cursor; goto stringsq; }
#line 591 "./mql_get_query.cpp"
yy76:
	++YYCURSOR;
#line 253 "./mql_gq.re"
	{ if (cursor == eof) { goto end; } }
#line 596 "./mql_get_query.cpp"
yy78:
	++YYCURSOR;
#line 254 "./mql_gq.re"
	{ pBigstring->addChar(*tok); cur = cursor; goto stringsq; }
#line 601 "./mql_get_query.cpp"
}
#line 255 "./mql_gq.re"



	
 end:
        Bigstring *result = pBigstring;
        pBigstring = 0;
	return result;
}



/*
int main(int argc, char *argv[])
{
      MQLGQScanner sc(&std::cin);
      while (!sc.noMoreInput()) {
           Bigstring *pBigstring = sc.scan();
           std::string result;
           pBigstring->toString(result);
           std::cerr << "UP200: '" << result << "'" << std::endl;
           delete pBigstring;
      }
}

*/
