/* Generated by re2c 0.12.3 on Sat Aug 15 14:16:47 2009 */
#line 1 "./mql.re"
/*
 * mql.re
 *
 * MQL Lexer based on re2c
 *
 * Ulrik Petersen
 * Created: 6/23-2007
 * Last update: 10/8-2007
 *
 */
/************************************************************************
 *
 *   Emdros - the database engine for analyzed or annotated text
 *   Copyright (C) 2001-2007  Ulrik Petersen
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation, license version 2.  
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *   02111-1307 USA
 *
 *
 *   Special exception
 *   =================
 * 
 *   In addition, as a special exception, Ulrik Petersen, the
 *   copyright holder of Emdros, gives permission to link Emdros, in
 *   whole or in part, with the libraries which are normally
 *   distributed with:
 *   
 *   a) Sun's Java platform,
 *   b) Python, 
 *   c) Jython,
 *   d) Ruby, and/or 
 *   e) Perl 
 *   f) PostgreSQL
 *   g) OpenSSL
 *
 *   (or with modified versions of these), and to distribute linked
 *   combinations including both Emdros, in whole or in part, and one
 *   or more of the libraries normally distributed with (a)-(g) above.
 *
 *   Please note: This gives you special rights concerning the
 *   libraries which normally accompany the above pieces of software.
 *   It gives you no special rights concerning software that you write
 *   yourself.  You must obey the GNU General Public License in all
 *   respects for all of the code used other than the libraries
 *   normally distributed with (a)-(g) above.
 *
 *   If you modify this file, you may extend this exception to your
 *   version of the file, but you are not obligated to do so. If you
 *   do not wish to do so, delete this exception statement from your
 *   version.
 *
 *
 *   Other licensing forms
 *   =====================
 *
 *   If you wish to negotiate commercial licensing, please contact
 *   Ulrik Petersen at ulrikp[at]users.sourceforge.net.
 *
 *   Licensing can also be negotiated if your organization is an
 *   educational, non-profit, charity, missionary or similar
 *   organization.
 *
 *
 *   Website
 *   =======
 *
 *   Emdros has a website here:
 *
 *   http://emdros.org
 *
 *
 *
 **************************************************************************/

/**@file mql_lexer.re
 *@brief Implementation file for MQL Lexer (MQL layer)
 */

#include <cstdlib>
#include <cstring>
#include <mql_lexer.h>
#include <mqlpars.h>
#include <iostream>
#include <string_func.h>

#define YYCTYPE         unsigned char
#define YYCURSOR        cur
#define YYLIMIT         lim
#define YYMARKER        ptr
#line 102 "./mql.re"



#line 137 "./mql.re"



MQLScanner::MQLScanner(const std::string& strIn)
{
	sz = strIn.c_str();
	lim = sz + strIn.length();
	bot = tok = ptr = pos = top = eof = 0;
	cur = sz;
}

MQLScanner::~MQLScanner()
{
	if (bot) {
		delete[] bot;
	}
}

/*
char *MQLScanner::fill(char *cursor)
{
        if(!eof)
        {
                unsigned int cnt = tok - bot;
                if(cnt)
                {
                        memcpy(bot, tok, lim - tok);
                        tok = bot;
                        ptr -= cnt;
                        cursor -= cnt;
                        pos -= cnt;
                        lim -= cnt;
                }
                if((top - lim) < BSIZE)
                {
                        char *buf = new char[(lim - bot) + BSIZE];
                        memcpy(buf, tok, lim - tok);
                        tok = buf;
                        ptr = &buf[ptr - bot];
                        cursor = &buf[cursor - bot];
                        pos = &buf[pos - bot];
                        lim = &buf[lim - bot];
                        top = &lim[BSIZE];
                        delete [] bot;
                        bot = buf;
                }
                pIn->read(lim, BSIZE);
                if ((cnt = pIn->gcount()) != BSIZE )
                {
                        eof = &lim[cnt]; *eof++ = '\0';
                }
                lim += cnt;
        }
        return cursor;
}
*/

#define TOKEN_RETURN(X,Y) { yylval->setName(X); return Y; }

int MQLScanner::scan(Token *pYYLVAL)
{
	yylval = pYYLVAL;

 scan:	
	tok = cur;


#line 174 "./mql_lexer.cpp"
{
	YYCTYPE yych;

	yych = *YYCURSOR;
	switch(yych) {
	case 0x00:	goto xx75;
	case 0x09:	goto xx69;
	case 0x0A:	goto xx73;
	case 0x0D:	goto xx71;
	case ' ':	goto xx67;
	case '!':	goto xx34;
	case '"':	goto xx63;
	case '\'':	goto xx65;
	case '(':	goto xx44;
	case ')':	goto xx46;
	case '*':	goto xx54;
	case ',':	goto xx52;
	case '-':	goto xx56;
	case '.':	goto xx23;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto xx61;
	case ':':	goto xx48;
	case ';':	goto xx50;
	case '<':	goto xx28;
	case '=':	goto xx26;
	case '>':	goto xx30;
	case 'A':
	case 'a':	goto xx10;
	case 'B':
	case 'b':	goto xx11;
	case 'C':
	case 'c':	goto xx2;
	case 'D':
	case 'd':	goto xx6;
	case 'E':
	case 'e':	goto xx17;
	case 'F':
	case 'f':	goto xx16;
	case 'G':
	case 'g':	goto xx7;
	case 'H':
	case 'h':	goto xx19;
	case 'I':
	case 'i':	goto xx8;
	case 'J':
	case 'P':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'j':
	case 'p':
	case 'x':
	case 'y':
	case 'z':	goto xx58;
	case 'K':
	case 'k':	goto xx21;
	case 'L':
	case 'l':	goto xx14;
	case 'M':
	case 'm':	goto xx18;
	case 'N':
	case 'n':	goto xx22;
	case 'O':
	case 'o':	goto xx13;
	case 'Q':
	case 'q':	goto xx25;
	case 'R':
	case 'r':	goto xx15;
	case 'S':
	case 's':	goto xx5;
	case 'T':
	case 't':	goto xx12;
	case 'U':
	case 'u':	goto xx4;
	case 'V':
	case 'v':	goto xx9;
	case 'W':
	case 'w':	goto xx20;
	case '[':	goto xx36;
	case ']':	goto xx38;
	case '`':	goto xx59;
	case '{':	goto xx40;
	case '}':	goto xx42;
	case '~':	goto xx32;
	default:	goto xx77;
	}
xx2:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'R') {
		if(yych <= 'N') {
			if(yych == 'A') goto xx495;
			goto xx93;
		} else {
			if(yych <= 'O') goto xx496;
			if(yych <= 'Q') goto xx93;
			goto xx497;
		}
	} else {
		if(yych <= 'n') {
			if(yych == 'a') goto xx495;
			goto xx93;
		} else {
			if(yych <= 'o') goto xx496;
			if(yych == 'r') goto xx497;
			goto xx93;
		}
	}
xx3:
#line 319 "./mql.re"
	{ addToken();
			      TOKEN_RETURN("identifier", T_IDENTIFIER);
			    }
#line 296 "./mql_lexer.cpp"
xx4:
	yych = *++YYCURSOR;
	if(yych <= 'S') {
		if(yych <= 'O') {
			if(yych == 'N') goto xx473;
			goto xx93;
		} else {
			if(yych <= 'P') goto xx474;
			if(yych <= 'R') goto xx93;
			goto xx475;
		}
	} else {
		if(yych <= 'o') {
			if(yych == 'n') goto xx473;
			goto xx93;
		} else {
			if(yych <= 'p') goto xx474;
			if(yych == 's') goto xx475;
			goto xx93;
		}
	}
xx5:
	yych = *++YYCURSOR;
	if(yych <= 'T') {
		if(yych <= 'G') {
			if(yych == 'E') goto xx440;
			goto xx93;
		} else {
			if(yych <= 'H') goto xx441;
			if(yych <= 'I') goto xx442;
			if(yych <= 'S') goto xx93;
			goto xx443;
		}
	} else {
		if(yych <= 'h') {
			if(yych == 'e') goto xx440;
			if(yych <= 'g') goto xx93;
			goto xx441;
		} else {
			if(yych <= 'i') goto xx442;
			if(yych == 't') goto xx443;
			goto xx93;
		}
	}
xx6:
	yych = *++YYCURSOR;
	if(yych <= 'R') {
		if(yych <= 'E') {
			if(yych == 'A') goto xx406;
			if(yych <= 'D') goto xx93;
			goto xx407;
		} else {
			if(yych == 'I') goto xx408;
			if(yych <= 'Q') goto xx93;
			goto xx409;
		}
	} else {
		if(yych <= 'e') {
			if(yych == 'a') goto xx406;
			if(yych <= 'd') goto xx93;
			goto xx407;
		} else {
			if(yych <= 'i') {
				if(yych <= 'h') goto xx93;
				goto xx408;
			} else {
				if(yych == 'r') goto xx409;
				goto xx93;
			}
		}
	}
xx7:
	yych = *++YYCURSOR;
	if(yych <= 'O') {
		if(yych <= 'D') {
			if(yych == 'A') goto xx396;
			goto xx93;
		} else {
			if(yych <= 'E') goto xx397;
			if(yych <= 'N') goto xx93;
			goto xx398;
		}
	} else {
		if(yych <= 'd') {
			if(yych == 'a') goto xx396;
			goto xx93;
		} else {
			if(yych <= 'e') goto xx397;
			if(yych == 'o') goto xx398;
			goto xx93;
		}
	}
xx8:
	yych = *++YYCURSOR;
	if(yych <= 'N') {
		if(yych == 'D') goto xx355;
		if(yych <= 'M') goto xx93;
		goto xx356;
	} else {
		if(yych <= 'd') {
			if(yych <= 'c') goto xx93;
			goto xx355;
		} else {
			if(yych == 'n') goto xx356;
			goto xx93;
		}
	}
xx9:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx349;
	if(yych == 'a') goto xx349;
	goto xx93;
xx10:
	yych = *++YYCURSOR;
	switch(yych) {
	case 'B':
	case 'b':	goto xx321;
	case 'D':
	case 'd':	goto xx322;
	case 'L':
	case 'l':	goto xx323;
	case 'N':
	case 'n':	goto xx324;
	case 'S':
	case 's':	goto xx325;
	case 'T':
	case 't':	goto xx327;
	default:	goto xx93;
	}
xx11:
	yych = *++YYCURSOR;
	if(yych <= 'Y') {
		if(yych == 'E') goto xx308;
		if(yych <= 'X') goto xx93;
		goto xx309;
	} else {
		if(yych <= 'e') {
			if(yych <= 'd') goto xx93;
			goto xx308;
		} else {
			if(yych == 'y') goto xx309;
			goto xx93;
		}
	}
xx12:
	yych = *++YYCURSOR;
	if(yych <= 'Y') {
		if(yych == 'R') goto xx291;
		if(yych <= 'X') goto xx93;
		goto xx292;
	} else {
		if(yych <= 'r') {
			if(yych <= 'q') goto xx93;
			goto xx291;
		} else {
			if(yych == 'y') goto xx292;
			goto xx93;
		}
	}
xx13:
	yych = *++YYCURSOR;
	if(yych <= 'R') {
		if(yych <= 'F') {
			if(yych == 'B') goto xx277;
			if(yych <= 'E') goto xx93;
			goto xx278;
		} else {
			if(yych == 'N') goto xx280;
			if(yych <= 'Q') goto xx93;
			goto xx282;
		}
	} else {
		if(yych <= 'f') {
			if(yych == 'b') goto xx277;
			if(yych <= 'e') goto xx93;
			goto xx278;
		} else {
			if(yych <= 'n') {
				if(yych <= 'm') goto xx93;
				goto xx280;
			} else {
				if(yych == 'r') goto xx282;
				goto xx93;
			}
		}
	}
xx14:
	yych = *++YYCURSOR;
	if(yych <= 'I') {
		if(yych == 'A') goto xx269;
		if(yych <= 'H') goto xx93;
		goto xx270;
	} else {
		if(yych <= 'a') {
			if(yych <= '`') goto xx93;
			goto xx269;
		} else {
			if(yych == 'i') goto xx270;
			goto xx93;
		}
	}
xx15:
	yych = *++YYCURSOR;
	if(yych <= 'E') {
		if(yych == 'A') goto xx238;
		if(yych <= 'D') goto xx93;
		goto xx239;
	} else {
		if(yych <= 'a') {
			if(yych <= '`') goto xx93;
			goto xx238;
		} else {
			if(yych == 'e') goto xx239;
			goto xx93;
		}
	}
xx16:
	yych = *++YYCURSOR;
	switch(yych) {
	case 'E':
	case 'e':	goto xx207;
	case 'I':
	case 'i':	goto xx208;
	case 'L':
	case 'l':	goto xx209;
	case 'O':
	case 'o':	goto xx210;
	case 'R':
	case 'r':	goto xx211;
	case 'U':
	case 'u':	goto xx212;
	default:	goto xx93;
	}
xx17:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx186;
	if(yych == 'n') goto xx186;
	goto xx93;
xx18:
	yych = *++YYCURSOR;
	if(yych <= 'U') {
		if(yych <= 'I') {
			if(yych == 'A') goto xx161;
			if(yych <= 'H') goto xx93;
			goto xx162;
		} else {
			if(yych == 'O') goto xx163;
			if(yych <= 'T') goto xx93;
			goto xx164;
		}
	} else {
		if(yych <= 'i') {
			if(yych == 'a') goto xx161;
			if(yych <= 'h') goto xx93;
			goto xx162;
		} else {
			if(yych <= 'o') {
				if(yych <= 'n') goto xx93;
				goto xx163;
			} else {
				if(yych == 'u') goto xx164;
				goto xx93;
			}
		}
	}
xx19:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx153;
	if(yych == 'a') goto xx153;
	goto xx93;
xx20:
	yych = *++YYCURSOR;
	if(yych <= 'I') {
		if(yych <= 'G') goto xx93;
		if(yych <= 'H') goto xx140;
		goto xx141;
	} else {
		if(yych <= 'g') goto xx93;
		if(yych <= 'h') goto xx140;
		if(yych <= 'i') goto xx141;
		goto xx93;
	}
xx21:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx137;
	if(yych == 'e') goto xx137;
	goto xx93;
xx22:
	yych = *++YYCURSOR;
	if(yych <= 'O') {
		if(yych == 'I') goto xx114;
		if(yych <= 'N') goto xx93;
		goto xx115;
	} else {
		if(yych <= 'i') {
			if(yych <= 'h') goto xx93;
			goto xx114;
		} else {
			if(yych == 'o') goto xx115;
			goto xx93;
		}
	}
xx23:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '.') goto xx112;
#line 315 "./mql.re"
	{ TOKEN_RETURN(".", T_KEY_DOT); }
#line 604 "./mql_lexer.cpp"
xx25:
	yych = *++YYCURSOR;
	if(yych == 'U') goto xx108;
	if(yych == 'u') goto xx108;
	goto xx93;
xx26:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '<') goto xx106;
	if(yych == '>') goto xx104;
#line 295 "./mql.re"
	{ TOKEN_RETURN("=", T_KEY_EQUALS);  }
#line 616 "./mql_lexer.cpp"
xx28:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '<') goto xx29;
	if(yych <= '=') goto xx100;
	if(yych <= '>') goto xx102;
xx29:
#line 296 "./mql.re"
	{ TOKEN_RETURN("<", T_KEY_LESS_THAN);  }
#line 625 "./mql_lexer.cpp"
xx30:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '=') goto xx98;
#line 297 "./mql.re"
	{ TOKEN_RETURN(">", T_KEY_GREATER_THAN);  }
#line 631 "./mql_lexer.cpp"
xx32:
	++YYCURSOR;
#line 303 "./mql.re"
	{ TOKEN_RETURN("~", T_KEY_TILDE); }
#line 636 "./mql_lexer.cpp"
xx34:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '~') goto xx96;
#line 318 "./mql.re"
	{ TOKEN_RETURN("!", T_KEY_EXCLAMATION); }
#line 642 "./mql_lexer.cpp"
xx36:
	++YYCURSOR;
#line 305 "./mql.re"
	{ TOKEN_RETURN("[", T_KEY_OPEN_SQUARE_BRACKET); }
#line 647 "./mql_lexer.cpp"
xx38:
	++YYCURSOR;
#line 306 "./mql.re"
	{ TOKEN_RETURN("]", T_KEY_CLOSE_SQUARE_BRACKET); }
#line 652 "./mql_lexer.cpp"
xx40:
	++YYCURSOR;
#line 307 "./mql.re"
	{ TOKEN_RETURN("{", T_KEY_OPEN_BRACE);  }
#line 657 "./mql_lexer.cpp"
xx42:
	++YYCURSOR;
#line 308 "./mql.re"
	{ TOKEN_RETURN("}", T_KEY_CLOSE_BRACE);  }
#line 662 "./mql_lexer.cpp"
xx44:
	++YYCURSOR;
#line 309 "./mql.re"
	{ TOKEN_RETURN("(", T_KEY_OPEN_BRACKET); }
#line 667 "./mql_lexer.cpp"
xx46:
	++YYCURSOR;
#line 310 "./mql.re"
	{ TOKEN_RETURN(")", T_KEY_CLOSE_BRACKET); }
#line 672 "./mql_lexer.cpp"
xx48:
	++YYCURSOR;
	if((yych = *YYCURSOR) == '=') goto xx94;
#line 312 "./mql.re"
	{ TOKEN_RETURN(":", T_KEY_COLON); }
#line 678 "./mql_lexer.cpp"
xx50:
	++YYCURSOR;
#line 313 "./mql.re"
	{ TOKEN_RETURN(";", T_KEY_SEMICOLON); }
#line 683 "./mql_lexer.cpp"
xx52:
	++YYCURSOR;
#line 314 "./mql.re"
	{ TOKEN_RETURN(",", T_KEY_COMMA); }
#line 688 "./mql_lexer.cpp"
xx54:
	++YYCURSOR;
#line 316 "./mql.re"
	{ TOKEN_RETURN("*", T_KEY_STAR); }
#line 693 "./mql_lexer.cpp"
xx56:
	++YYCURSOR;
#line 317 "./mql.re"
	{ TOKEN_RETURN("-", T_KEY_DASH); }
#line 698 "./mql_lexer.cpp"
xx58:
	yych = *++YYCURSOR;
	goto xx93;
xx59:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '^') {
		if(yych <= '@') goto xx60;
		if(yych <= 'Z') goto xx87;
	} else {
		if(yych == '`') goto xx60;
		if(yych <= 'z') goto xx87;
	}
xx60:
#line 337 "./mql.re"
	{ yylval->setChar(*tok);
	    TOKEN_RETURN(CHAR_MAGIC, *tok); }
#line 715 "./mql_lexer.cpp"
xx61:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '/') goto xx62;
	if(yych <= '9') goto xx78;
xx62:
#line 324 "./mql.re"
	{ addInteger();
                              TOKEN_RETURN(INTEGER_MAGIC, T_INTEGER); }
#line 724 "./mql_lexer.cpp"
xx63:
	++YYCURSOR;
#line 326 "./mql.re"
	{ yylval->setString(new std::string);
			      goto stringdq; 
                            }
#line 731 "./mql_lexer.cpp"
xx65:
	++YYCURSOR;
#line 329 "./mql.re"
	{ yylval->setString(new std::string);
			      goto stringsq; 
			    }
#line 738 "./mql_lexer.cpp"
xx67:
	++YYCURSOR;
#line 332 "./mql.re"
	{ goto scan; }
#line 743 "./mql_lexer.cpp"
xx69:
	++YYCURSOR;
#line 333 "./mql.re"
	{ goto scan; }
#line 748 "./mql_lexer.cpp"
xx71:
	++YYCURSOR;
#line 334 "./mql.re"
	{ goto scan; }
#line 753 "./mql_lexer.cpp"
xx73:
	++YYCURSOR;
#line 335 "./mql.re"
	{ goto scan; }
#line 758 "./mql_lexer.cpp"
xx75:
	++YYCURSOR;
#line 336 "./mql.re"
	{ if (cur >= lim) { goto end; } }
#line 763 "./mql_lexer.cpp"
xx77:
	yych = *++YYCURSOR;
	goto xx60;
xx78:
	yych = *++YYCURSOR;
	if(yych <= '/') goto xx62;
	if(yych >= ':') goto xx62;
	yych = *++YYCURSOR;
	if(yych <= '/') goto xx62;
	if(yych >= ':') goto xx62;
	yych = *++YYCURSOR;
	if(yych <= '/') goto xx62;
	if(yych >= ':') goto xx62;
	yych = *++YYCURSOR;
	if(yych <= '/') goto xx62;
	if(yych >= ':') goto xx62;
	yych = *++YYCURSOR;
	if(yych <= '/') goto xx62;
	if(yych >= ':') goto xx62;
	yych = *++YYCURSOR;
	if(yych <= '/') goto xx62;
	if(yych >= ':') goto xx62;
	yych = *++YYCURSOR;
	if(yych <= '/') goto xx62;
	if(yych >= ':') goto xx62;
	yych = *++YYCURSOR;
	if(yych <= '/') goto xx62;
	if(yych >= ':') goto xx62;
	yych = *++YYCURSOR;
	goto xx62;
xx87:
	YYMARKER = ++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= 'Z') {
		if(yych <= '/') goto xx89;
		if(yych <= '9') goto xx87;
		if(yych >= 'A') goto xx87;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx87;
		} else {
			if(yych <= '`') goto xx90;
			if(yych <= 'z') goto xx87;
		}
	}
xx89:
#line 322 "./mql.re"
	{ addToken();
                                           TOKEN_RETURN("mark", T_MARK); }
#line 813 "./mql_lexer.cpp"
xx90:
	++YYCURSOR;
	yych = *YYCURSOR;
	if(yych <= '^') {
		if(yych <= '@') goto xx91;
		if(yych <= 'Z') goto xx87;
	} else {
		if(yych == '`') goto xx91;
		if(yych <= 'z') goto xx87;
	}
xx91:
	YYCURSOR = YYMARKER;
	goto xx89;
xx92:
	++YYCURSOR;
	yych = *YYCURSOR;
xx93:
	if(yych <= 'Z') {
		if(yych <= '/') goto xx3;
		if(yych <= '9') goto xx92;
		if(yych <= '@') goto xx3;
		goto xx92;
	} else {
		if(yych <= '_') {
			if(yych <= '^') goto xx3;
			goto xx92;
		} else {
			if(yych <= '`') goto xx3;
			if(yych <= 'z') goto xx92;
			goto xx3;
		}
	}
xx94:
	++YYCURSOR;
#line 311 "./mql.re"
	{ TOKEN_RETURN(":=", T_KEY_ASSIGN);  }
#line 850 "./mql_lexer.cpp"
xx96:
	++YYCURSOR;
#line 304 "./mql.re"
	{ TOKEN_RETURN("!~", T_KEY_NOT_TILDE); }
#line 855 "./mql_lexer.cpp"
xx98:
	++YYCURSOR;
#line 301 "./mql.re"
	{ TOKEN_RETURN(">=", T_KEY_GREATER_THAN_OR_EQUAL);  }
#line 860 "./mql_lexer.cpp"
xx100:
	++YYCURSOR;
#line 299 "./mql.re"
	{ TOKEN_RETURN("<=", T_KEY_LESS_THAN_OR_EQUAL);  }
#line 865 "./mql_lexer.cpp"
xx102:
	++YYCURSOR;
#line 298 "./mql.re"
	{ TOKEN_RETURN("<>", T_KEY_NOT_EQUAL);  }
#line 870 "./mql_lexer.cpp"
xx104:
	++YYCURSOR;
#line 302 "./mql.re"
	{ TOKEN_RETURN("=>", T_KEY_GREATER_THAN_OR_EQUAL);  }
#line 875 "./mql_lexer.cpp"
xx106:
	++YYCURSOR;
#line 300 "./mql.re"
	{ TOKEN_RETURN("=<", T_KEY_LESS_THAN_OR_EQUAL);  }
#line 880 "./mql_lexer.cpp"
xx108:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx109;
	if(yych != 'i') goto xx93;
xx109:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx110;
	if(yych != 't') goto xx93;
xx110:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx111;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx111;
			if(yych <= 'z') goto xx92;
		}
	}
xx111:
#line 287 "./mql.re"
	{ TOKEN_RETURN("quit", T_KEY_QUIT); }
#line 906 "./mql_lexer.cpp"
xx112:
	++YYCURSOR;
#line 273 "./mql.re"
	{ TOKEN_RETURN("..", T_KEY_POWER);  }
#line 911 "./mql_lexer.cpp"
xx114:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx135;
	if(yych == 'l') goto xx135;
	goto xx93;
xx115:
	yych = *++YYCURSOR;
	if(yych <= 'T') {
		if(yych == 'R') goto xx116;
		if(yych <= 'S') goto xx93;
		goto xx117;
	} else {
		if(yych <= 'r') {
			if(yych <= 'q') goto xx93;
		} else {
			if(yych == 't') goto xx117;
			goto xx93;
		}
	}
xx116:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx127;
	if(yych == 'e') goto xx127;
	goto xx93;
xx117:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx118;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'E') goto xx119;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 'e') goto xx119;
			if(yych <= 'z') goto xx92;
		}
	}
xx118:
#line 268 "./mql.re"
	{ TOKEN_RETURN("not", T_KEY_NOT);  }
#line 957 "./mql_lexer.cpp"
xx119:
	yych = *++YYCURSOR;
	if(yych == 'X') goto xx120;
	if(yych != 'x') goto xx93;
xx120:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx121;
	if(yych != 'i') goto xx93;
xx121:
	yych = *++YYCURSOR;
	if(yych == 'S') goto xx122;
	if(yych != 's') goto xx93;
xx122:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx123;
	if(yych != 't') goto xx93;
xx123:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx124;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'S') goto xx125;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 's') goto xx125;
			if(yych <= 'z') goto xx92;
		}
	}
xx124:
#line 269 "./mql.re"
	{ TOKEN_RETURN("notexist", T_KEY_NOTEXIST);  }
#line 995 "./mql_lexer.cpp"
xx125:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx126;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx126;
			if(yych <= 'z') goto xx92;
		}
	}
xx126:
#line 270 "./mql.re"
	{ TOKEN_RETURN("notexists", T_KEY_NOTEXISTS);  }
#line 1013 "./mql_lexer.cpp"
xx127:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx128;
	if(yych != 't') goto xx93;
xx128:
	yych = *++YYCURSOR;
	if(yych == 'R') goto xx129;
	if(yych != 'r') goto xx93;
xx129:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx130;
	if(yych != 'i') goto xx93;
xx130:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx131;
	if(yych != 'e') goto xx93;
xx131:
	yych = *++YYCURSOR;
	if(yych == 'V') goto xx132;
	if(yych != 'v') goto xx93;
xx132:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx133;
	if(yych != 'e') goto xx93;
xx133:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx134;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx134;
			if(yych <= 'z') goto xx92;
		}
	}
xx134:
#line 262 "./mql.re"
	{ TOKEN_RETURN("noretrieve", T_KEY_NORETRIEVE);  }
#line 1055 "./mql_lexer.cpp"
xx135:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx136;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx136;
			if(yych <= 'z') goto xx92;
		}
	}
xx136:
#line 276 "./mql.re"
	{ TOKEN_RETURN("nil", T_KEY_NIL);  }
#line 1073 "./mql_lexer.cpp"
xx137:
	yych = *++YYCURSOR;
	if(yych == 'Y') goto xx138;
	if(yych != 'y') goto xx93;
xx138:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx139;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx139;
			if(yych <= 'z') goto xx92;
		}
	}
xx139:
#line 261 "./mql.re"
	{ TOKEN_RETURN("key", T_KEY_KEY); }
#line 1095 "./mql_lexer.cpp"
xx140:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx149;
	if(yych == 'e') goto xx149;
	goto xx93;
xx141:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx142;
	if(yych != 't') goto xx93;
xx142:
	yych = *++YYCURSOR;
	if(yych == 'H') goto xx143;
	if(yych != 'h') goto xx93;
xx143:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx144;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'O') goto xx145;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 'o') goto xx145;
			if(yych <= 'z') goto xx92;
		}
	}
xx144:
#line 259 "./mql.re"
	{ TOKEN_RETURN("with", T_KEY_WITH);  }
#line 1130 "./mql_lexer.cpp"
xx145:
	yych = *++YYCURSOR;
	if(yych == 'U') goto xx146;
	if(yych != 'u') goto xx93;
xx146:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx147;
	if(yych != 't') goto xx93;
xx147:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx148;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx148;
			if(yych <= 'z') goto xx92;
		}
	}
xx148:
#line 260 "./mql.re"
	{ TOKEN_RETURN("without", T_KEY_WITHOUT);  }
#line 1156 "./mql_lexer.cpp"
xx149:
	yych = *++YYCURSOR;
	if(yych == 'R') goto xx150;
	if(yych != 'r') goto xx93;
xx150:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx151;
	if(yych != 'e') goto xx93;
xx151:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx152;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx152;
			if(yych <= 'z') goto xx92;
		}
	}
xx152:
#line 251 "./mql.re"
	{ TOKEN_RETURN("where", T_KEY_WHERE);  }
#line 1182 "./mql_lexer.cpp"
xx153:
	yych = *++YYCURSOR;
	if(yych <= 'V') {
		if(yych == 'S') goto xx154;
		if(yych <= 'U') goto xx93;
		goto xx156;
	} else {
		if(yych <= 's') {
			if(yych <= 'r') goto xx93;
		} else {
			if(yych == 'v') goto xx156;
			goto xx93;
		}
	}
xx154:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx155;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx155;
			if(yych <= 'z') goto xx92;
		}
	}
xx155:
#line 250 "./mql.re"
	{ TOKEN_RETURN("has", T_KEY_HAS);  }
#line 1214 "./mql_lexer.cpp"
xx156:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx157;
	if(yych != 'i') goto xx93;
xx157:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx158;
	if(yych != 'n') goto xx93;
xx158:
	yych = *++YYCURSOR;
	if(yych == 'G') goto xx159;
	if(yych != 'g') goto xx93;
xx159:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx160;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx160;
			if(yych <= 'z') goto xx92;
		}
	}
xx160:
#line 252 "./mql.re"
	{ TOKEN_RETURN("having", T_KEY_HAVING); }
#line 1244 "./mql_lexer.cpp"
xx161:
	yych = *++YYCURSOR;
	if(yych == 'X') goto xx182;
	if(yych == 'x') goto xx182;
	goto xx93;
xx162:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx178;
	if(yych == 'n') goto xx178;
	goto xx93;
xx163:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx172;
	if(yych == 'n') goto xx172;
	goto xx93;
xx164:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx165;
	if(yych != 'l') goto xx93;
xx165:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx166;
	if(yych != 't') goto xx93;
xx166:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx167;
	if(yych != 'i') goto xx93;
xx167:
	yych = *++YYCURSOR;
	if(yych == 'P') goto xx168;
	if(yych != 'p') goto xx93;
xx168:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx169;
	if(yych != 'l') goto xx93;
xx169:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx170;
	if(yych != 'e') goto xx93;
xx170:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx171;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx171;
			if(yych <= 'z') goto xx92;
		}
	}
xx171:
#line 247 "./mql.re"
	{ TOKEN_RETURN("multiple", T_KEY_MULTIPLE); }
#line 1301 "./mql_lexer.cpp"
xx172:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx173;
	if(yych != 'a') goto xx93;
xx173:
	yych = *++YYCURSOR;
	if(yych == 'D') goto xx174;
	if(yych != 'd') goto xx93;
xx174:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx175;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'S') goto xx176;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 's') goto xx176;
			if(yych <= 'z') goto xx92;
		}
	}
xx175:
#line 256 "./mql.re"
	{ TOKEN_RETURN("monad", T_KEY_MONAD);  }
#line 1331 "./mql_lexer.cpp"
xx176:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx177;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx177;
			if(yych <= 'z') goto xx92;
		}
	}
xx177:
#line 255 "./mql.re"
	{ TOKEN_RETURN("monads", T_KEY_MONADS);  }
#line 1349 "./mql_lexer.cpp"
xx178:
	yych = *++YYCURSOR;
	if(yych != '_') goto xx93;
	yych = *++YYCURSOR;
	if(yych == 'M') goto xx180;
	if(yych != 'm') goto xx93;
xx180:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx181;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx181;
			if(yych <= 'z') goto xx92;
		}
	}
xx181:
#line 280 "./mql.re"
	{ TOKEN_RETURN("min_m", T_KEY_MIN_M); }
#line 1373 "./mql_lexer.cpp"
xx182:
	yych = *++YYCURSOR;
	if(yych != '_') goto xx93;
	yych = *++YYCURSOR;
	if(yych == 'M') goto xx184;
	if(yych != 'm') goto xx93;
xx184:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx185;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx185;
			if(yych <= 'z') goto xx92;
		}
	}
xx185:
#line 281 "./mql.re"
	{ TOKEN_RETURN("max_m", T_KEY_MAX_M); }
#line 1397 "./mql_lexer.cpp"
xx186:
	yych = *++YYCURSOR;
	if(yych <= 'U') {
		if(yych == 'C') goto xx188;
		if(yych <= 'T') goto xx93;
	} else {
		if(yych <= 'c') {
			if(yych <= 'b') goto xx93;
			goto xx188;
		} else {
			if(yych != 'u') goto xx93;
		}
	}
	yych = *++YYCURSOR;
	if(yych == 'M') goto xx195;
	if(yych == 'm') goto xx195;
	goto xx93;
xx188:
	yych = *++YYCURSOR;
	if(yych == 'O') goto xx189;
	if(yych != 'o') goto xx93;
xx189:
	yych = *++YYCURSOR;
	if(yych == 'D') goto xx190;
	if(yych != 'd') goto xx93;
xx190:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx191;
	if(yych != 'i') goto xx93;
xx191:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx192;
	if(yych != 'n') goto xx93;
xx192:
	yych = *++YYCURSOR;
	if(yych == 'G') goto xx193;
	if(yych != 'g') goto xx93;
xx193:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx194;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx194;
			if(yych <= 'z') goto xx92;
		}
	}
xx194:
#line 294 "./mql.re"
	{ TOKEN_RETURN("encoding", T_KEY_ENCODING); }
#line 1452 "./mql_lexer.cpp"
xx195:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx196;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'E') goto xx197;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 'e') goto xx197;
			if(yych <= 'z') goto xx92;
		}
	}
xx196:
#line 240 "./mql.re"
	{ TOKEN_RETURN("enum", T_KEY_ENUM);  }
#line 1474 "./mql_lexer.cpp"
xx197:
	yych = *++YYCURSOR;
	if(yych == 'R') goto xx198;
	if(yych != 'r') goto xx93;
xx198:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx199;
	if(yych != 'a') goto xx93;
xx199:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx200;
	if(yych != 't') goto xx93;
xx200:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx201;
	if(yych != 'i') goto xx93;
xx201:
	yych = *++YYCURSOR;
	if(yych == 'O') goto xx202;
	if(yych != 'o') goto xx93;
xx202:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx203;
	if(yych != 'n') goto xx93;
xx203:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx204;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'S') goto xx205;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 's') goto xx205;
			if(yych <= 'z') goto xx92;
		}
	}
xx204:
#line 241 "./mql.re"
	{ TOKEN_RETURN("enumeration", T_KEY_ENUMERATION);  }
#line 1520 "./mql_lexer.cpp"
xx205:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx206;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx206;
			if(yych <= 'z') goto xx92;
		}
	}
xx206:
#line 242 "./mql.re"
	{ TOKEN_RETURN("enumerations", T_KEY_ENUMERATIONS);  }
#line 1538 "./mql_lexer.cpp"
xx207:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx230;
	if(yych == 'a') goto xx230;
	goto xx93;
xx208:
	yych = *++YYCURSOR;
	if(yych == 'R') goto xx226;
	if(yych == 'r') goto xx226;
	goto xx93;
xx209:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx223;
	if(yych == 'a') goto xx223;
	goto xx93;
xx210:
	yych = *++YYCURSOR;
	if(yych == 'C') goto xx219;
	if(yych == 'c') goto xx219;
	goto xx93;
xx211:
	yych = *++YYCURSOR;
	if(yych == 'O') goto xx216;
	if(yych == 'o') goto xx216;
	goto xx93;
xx212:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx213;
	if(yych != 'l') goto xx93;
xx213:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx214;
	if(yych != 'l') goto xx93;
xx214:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx215;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx215;
			if(yych <= 'z') goto xx92;
		}
	}
xx215:
#line 283 "./mql.re"
	{ TOKEN_RETURN("full", T_KEY_FULL); }
#line 1589 "./mql_lexer.cpp"
xx216:
	yych = *++YYCURSOR;
	if(yych == 'M') goto xx217;
	if(yych != 'm') goto xx93;
xx217:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx218;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx218;
			if(yych <= 'z') goto xx92;
		}
	}
xx218:
#line 238 "./mql.re"
	{ TOKEN_RETURN("from", T_KEY_FROM);  }
#line 1611 "./mql_lexer.cpp"
xx219:
	yych = *++YYCURSOR;
	if(yych == 'U') goto xx220;
	if(yych != 'u') goto xx93;
xx220:
	yych = *++YYCURSOR;
	if(yych == 'S') goto xx221;
	if(yych != 's') goto xx93;
xx221:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx222;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx222;
			if(yych <= 'z') goto xx92;
		}
	}
xx222:
#line 248 "./mql.re"
	{ TOKEN_RETURN("focus", T_KEY_FOCUS);  }
#line 1637 "./mql_lexer.cpp"
xx223:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx224;
	if(yych != 't') goto xx93;
xx224:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx225;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx225;
			if(yych <= 'z') goto xx92;
		}
	}
xx225:
#line 282 "./mql.re"
	{ TOKEN_RETURN("flat", T_KEY_FLAT); }
#line 1659 "./mql_lexer.cpp"
xx226:
	yych = *++YYCURSOR;
	if(yych == 'S') goto xx227;
	if(yych != 's') goto xx93;
xx227:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx228;
	if(yych != 't') goto xx93;
xx228:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx229;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx229;
			if(yych <= 'z') goto xx92;
		}
	}
xx229:
#line 264 "./mql.re"
	{ TOKEN_RETURN("first", T_KEY_FIRST);  }
#line 1685 "./mql_lexer.cpp"
xx230:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx231;
	if(yych != 't') goto xx93;
xx231:
	yych = *++YYCURSOR;
	if(yych == 'U') goto xx232;
	if(yych != 'u') goto xx93;
xx232:
	yych = *++YYCURSOR;
	if(yych == 'R') goto xx233;
	if(yych != 'r') goto xx93;
xx233:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx234;
	if(yych != 'e') goto xx93;
xx234:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx235;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'S') goto xx236;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 's') goto xx236;
			if(yych <= 'z') goto xx92;
		}
	}
xx235:
#line 253 "./mql.re"
	{ TOKEN_RETURN("feature", T_KEY_FEATURE);  }
#line 1723 "./mql_lexer.cpp"
xx236:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx237;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx237;
			if(yych <= 'z') goto xx92;
		}
	}
xx237:
#line 254 "./mql.re"
	{ TOKEN_RETURN("features", T_KEY_FEATURES);  }
#line 1741 "./mql_lexer.cpp"
xx238:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx265;
	if(yych == 'n') goto xx265;
	goto xx93;
xx239:
	yych = *++YYCURSOR;
	if(yych <= 'T') {
		if(yych <= 'O') {
			if(yych != 'M') goto xx93;
		} else {
			if(yych <= 'P') goto xx242;
			if(yych <= 'S') goto xx93;
			goto xx241;
		}
	} else {
		if(yych <= 'o') {
			if(yych != 'm') goto xx93;
		} else {
			if(yych <= 'p') goto xx242;
			if(yych == 't') goto xx241;
			goto xx93;
		}
	}
	yych = *++YYCURSOR;
	if(yych == 'O') goto xx261;
	if(yych == 'o') goto xx261;
	goto xx93;
xx241:
	yych = *++YYCURSOR;
	if(yych <= 'U') {
		if(yych == 'R') goto xx248;
		if(yych <= 'T') goto xx93;
		goto xx249;
	} else {
		if(yych <= 'r') {
			if(yych <= 'q') goto xx93;
			goto xx248;
		} else {
			if(yych == 'u') goto xx249;
			goto xx93;
		}
	}
xx242:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx243;
	if(yych != 'l') goto xx93;
xx243:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx244;
	if(yych != 'a') goto xx93;
xx244:
	yych = *++YYCURSOR;
	if(yych == 'C') goto xx245;
	if(yych != 'c') goto xx93;
xx245:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx246;
	if(yych != 'e') goto xx93;
xx246:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx247;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx247;
			if(yych <= 'z') goto xx92;
		}
	}
xx247:
#line 293 "./mql.re"
	{ TOKEN_RETURN("replace", T_KEY_REPLACE); }
#line 1818 "./mql_lexer.cpp"
xx248:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx256;
	if(yych == 'i') goto xx256;
	goto xx93;
xx249:
	yych = *++YYCURSOR;
	if(yych == 'R') goto xx250;
	if(yych != 'r') goto xx93;
xx250:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx251;
	if(yych != 'n') goto xx93;
xx251:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx252;
	if(yych != 'i') goto xx93;
xx252:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx253;
	if(yych != 'n') goto xx93;
xx253:
	yych = *++YYCURSOR;
	if(yych == 'G') goto xx254;
	if(yych != 'g') goto xx93;
xx254:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx255;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx255;
			if(yych <= 'z') goto xx92;
		}
	}
xx255:
#line 278 "./mql.re"
	{ TOKEN_RETURN("returning", T_KEY_RETURNING); }
#line 1861 "./mql_lexer.cpp"
xx256:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx257;
	if(yych != 'e') goto xx93;
xx257:
	yych = *++YYCURSOR;
	if(yych == 'V') goto xx258;
	if(yych != 'v') goto xx93;
xx258:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx259;
	if(yych != 'e') goto xx93;
xx259:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx260;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx260;
			if(yych <= 'z') goto xx92;
		}
	}
xx260:
#line 263 "./mql.re"
	{ TOKEN_RETURN("retrieve", T_KEY_RETRIEVE);  }
#line 1891 "./mql_lexer.cpp"
xx261:
	yych = *++YYCURSOR;
	if(yych == 'V') goto xx262;
	if(yych != 'v') goto xx93;
xx262:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx263;
	if(yych != 'e') goto xx93;
xx263:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx264;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx264;
			if(yych <= 'z') goto xx92;
		}
	}
xx264:
#line 237 "./mql.re"
	{ TOKEN_RETURN("remove", T_KEY_REMOVE);  }
#line 1917 "./mql_lexer.cpp"
xx265:
	yych = *++YYCURSOR;
	if(yych == 'G') goto xx266;
	if(yych != 'g') goto xx93;
xx266:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx267;
	if(yych != 'e') goto xx93;
xx267:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx268;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx268;
			if(yych <= 'z') goto xx92;
		}
	}
xx268:
#line 245 "./mql.re"
	{ TOKEN_RETURN("range", T_KEY_RANGE);  }
#line 1943 "./mql_lexer.cpp"
xx269:
	yych = *++YYCURSOR;
	if(yych == 'S') goto xx274;
	if(yych == 's') goto xx274;
	goto xx93;
xx270:
	yych = *++YYCURSOR;
	if(yych == 'S') goto xx271;
	if(yych != 's') goto xx93;
xx271:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx272;
	if(yych != 't') goto xx93;
xx272:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx273;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx273;
			if(yych <= 'z') goto xx92;
		}
	}
xx273:
#line 224 "./mql.re"
	{ TOKEN_RETURN("list", T_KEY_LIST); }
#line 1974 "./mql_lexer.cpp"
xx274:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx275;
	if(yych != 't') goto xx93;
xx275:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx276;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx276;
			if(yych <= 'z') goto xx92;
		}
	}
xx276:
#line 265 "./mql.re"
	{ TOKEN_RETURN("last", T_KEY_LAST);  }
#line 1996 "./mql_lexer.cpp"
xx277:
	yych = *++YYCURSOR;
	if(yych == 'J') goto xx284;
	if(yych == 'j') goto xx284;
	goto xx93;
xx278:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx279;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx279;
			if(yych <= 'z') goto xx92;
		}
	}
xx279:
#line 225 "./mql.re"
	{ TOKEN_RETURN("of", T_KEY_OF); }
#line 2019 "./mql_lexer.cpp"
xx280:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx281;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx281;
			if(yych <= 'z') goto xx92;
		}
	}
xx281:
#line 284 "./mql.re"
	{ TOKEN_RETURN("on", T_KEY_ON); }
#line 2037 "./mql_lexer.cpp"
xx282:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx283;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx283;
			if(yych <= 'z') goto xx92;
		}
	}
xx283:
#line 266 "./mql.re"
	{ TOKEN_RETURN("or", T_KEY_OR);  }
#line 2055 "./mql_lexer.cpp"
xx284:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx285;
	if(yych != 'e') goto xx93;
xx285:
	yych = *++YYCURSOR;
	if(yych == 'C') goto xx286;
	if(yych != 'c') goto xx93;
xx286:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx287;
	if(yych != 't') goto xx93;
xx287:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx288;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'S') goto xx289;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 's') goto xx289;
			if(yych <= 'z') goto xx92;
		}
	}
xx288:
#line 222 "./mql.re"
	{ TOKEN_RETURN("object", T_KEY_OBJECT);  }
#line 2089 "./mql_lexer.cpp"
xx289:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx290;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx290;
			if(yych <= 'z') goto xx92;
		}
	}
xx290:
#line 223 "./mql.re"
	{ TOKEN_RETURN("objects", T_KEY_OBJECTS);  }
#line 2107 "./mql_lexer.cpp"
xx291:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx298;
	if(yych == 'a') goto xx298;
	goto xx93;
xx292:
	yych = *++YYCURSOR;
	if(yych == 'P') goto xx293;
	if(yych != 'p') goto xx93;
xx293:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx294;
	if(yych != 'e') goto xx93;
xx294:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx295;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'S') goto xx296;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 's') goto xx296;
			if(yych <= 'z') goto xx92;
		}
	}
xx295:
#line 220 "./mql.re"
	{ TOKEN_RETURN("type", T_KEY_TYPE);  }
#line 2142 "./mql_lexer.cpp"
xx296:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx297;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx297;
			if(yych <= 'z') goto xx92;
		}
	}
xx297:
#line 221 "./mql.re"
	{ TOKEN_RETURN("types", T_KEY_TYPES);  }
#line 2160 "./mql_lexer.cpp"
xx298:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx299;
	if(yych != 'n') goto xx93;
xx299:
	yych = *++YYCURSOR;
	if(yych == 'S') goto xx300;
	if(yych != 's') goto xx93;
xx300:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx301;
	if(yych != 'a') goto xx93;
xx301:
	yych = *++YYCURSOR;
	if(yych == 'C') goto xx302;
	if(yych != 'c') goto xx93;
xx302:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx303;
	if(yych != 't') goto xx93;
xx303:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx304;
	if(yych != 'i') goto xx93;
xx304:
	yych = *++YYCURSOR;
	if(yych == 'O') goto xx305;
	if(yych != 'o') goto xx93;
xx305:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx306;
	if(yych != 'n') goto xx93;
xx306:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx307;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx307;
			if(yych <= 'z') goto xx92;
		}
	}
xx307:
#line 219 "./mql.re"
	{ TOKEN_RETURN("transaction", T_KEY_TRANSACTION); }
#line 2210 "./mql_lexer.cpp"
xx308:
	yych = *++YYCURSOR;
	if(yych <= 'T') {
		if(yych == 'G') goto xx311;
		if(yych <= 'S') goto xx93;
		goto xx312;
	} else {
		if(yych <= 'g') {
			if(yych <= 'f') goto xx93;
			goto xx311;
		} else {
			if(yych == 't') goto xx312;
			goto xx93;
		}
	}
xx309:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx310;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx310;
			if(yych <= 'z') goto xx92;
		}
	}
xx310:
#line 239 "./mql.re"
	{ TOKEN_RETURN("by", T_KEY_BY);  }
#line 2243 "./mql_lexer.cpp"
xx311:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx318;
	if(yych == 'i') goto xx318;
	goto xx93;
xx312:
	yych = *++YYCURSOR;
	if(yych == 'W') goto xx313;
	if(yych != 'w') goto xx93;
xx313:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx314;
	if(yych != 'e') goto xx93;
xx314:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx315;
	if(yych != 'e') goto xx93;
xx315:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx316;
	if(yych != 'n') goto xx93;
xx316:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx317;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx317;
			if(yych <= 'z') goto xx92;
		}
	}
xx317:
#line 274 "./mql.re"
	{ TOKEN_RETURN("between", T_KEY_BETWEEN); }
#line 2282 "./mql_lexer.cpp"
xx318:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx319;
	if(yych != 'n') goto xx93;
xx319:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx320;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx320;
			if(yych <= 'z') goto xx92;
		}
	}
xx320:
#line 216 "./mql.re"
	{ TOKEN_RETURN("begin", T_KEY_BEGIN); }
#line 2304 "./mql_lexer.cpp"
xx321:
	yych = *++YYCURSOR;
	if(yych == 'O') goto xx345;
	if(yych == 'o') goto xx345;
	goto xx93;
xx322:
	yych = *++YYCURSOR;
	if(yych == 'D') goto xx343;
	if(yych == 'd') goto xx343;
	goto xx93;
xx323:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx341;
	if(yych == 'l') goto xx341;
	goto xx93;
xx324:
	yych = *++YYCURSOR;
	if(yych <= 'D') {
		if(yych == 'A') goto xx333;
		if(yych <= 'C') goto xx93;
		goto xx334;
	} else {
		if(yych <= 'a') {
			if(yych <= '`') goto xx93;
			goto xx333;
		} else {
			if(yych == 'd') goto xx334;
			goto xx93;
		}
	}
xx325:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx326;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'C') goto xx329;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 'c') goto xx329;
			if(yych <= 'z') goto xx92;
		}
	}
xx326:
#line 275 "./mql.re"
	{ TOKEN_RETURN("as", T_KEY_AS);  }
#line 2356 "./mql_lexer.cpp"
xx327:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx328;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx328;
			if(yych <= 'z') goto xx92;
		}
	}
xx328:
#line 286 "./mql.re"
	{ TOKEN_RETURN("at", T_KEY_AT); }
#line 2374 "./mql_lexer.cpp"
xx329:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx330;
	if(yych != 'i') goto xx93;
xx330:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx331;
	if(yych != 'i') goto xx93;
xx331:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx332;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx332;
			if(yych <= 'z') goto xx92;
		}
	}
xx332:
#line 231 "./mql.re"
	{ TOKEN_RETURN("ascii", T_KEY_ASCII); }
#line 2400 "./mql_lexer.cpp"
xx333:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx336;
	if(yych == 'l') goto xx336;
	goto xx93;
xx334:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx335;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx335;
			if(yych <= 'z') goto xx92;
		}
	}
xx335:
#line 267 "./mql.re"
	{ TOKEN_RETURN("and", T_KEY_AND);  }
#line 2423 "./mql_lexer.cpp"
xx336:
	yych = *++YYCURSOR;
	if(yych == 'Y') goto xx337;
	if(yych != 'y') goto xx93;
xx337:
	yych = *++YYCURSOR;
	if(yych == 'Z') goto xx338;
	if(yych != 'z') goto xx93;
xx338:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx339;
	if(yych != 'e') goto xx93;
xx339:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx340;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx340;
			if(yych <= 'z') goto xx92;
		}
	}
xx340:
#line 215 "./mql.re"
	{ TOKEN_RETURN("analyze", T_KEY_ANALYZE); }
#line 2453 "./mql_lexer.cpp"
xx341:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx342;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx342;
			if(yych <= 'z') goto xx92;
		}
	}
xx342:
#line 249 "./mql.re"
	{ TOKEN_RETURN("all", T_KEY_ALL);  }
#line 2471 "./mql_lexer.cpp"
xx343:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx344;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx344;
			if(yych <= 'z') goto xx92;
		}
	}
xx344:
#line 236 "./mql.re"
	{ TOKEN_RETURN("add", T_KEY_ADD);  }
#line 2489 "./mql_lexer.cpp"
xx345:
	yych = *++YYCURSOR;
	if(yych == 'R') goto xx346;
	if(yych != 'r') goto xx93;
xx346:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx347;
	if(yych != 't') goto xx93;
xx347:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx348;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx348;
			if(yych <= 'z') goto xx92;
		}
	}
xx348:
#line 218 "./mql.re"
	{ TOKEN_RETURN("abort", T_KEY_ABORT); }
#line 2515 "./mql_lexer.cpp"
xx349:
	yych = *++YYCURSOR;
	if(yych == 'C') goto xx350;
	if(yych != 'c') goto xx93;
xx350:
	yych = *++YYCURSOR;
	if(yych == 'U') goto xx351;
	if(yych != 'u') goto xx93;
xx351:
	yych = *++YYCURSOR;
	if(yych == 'U') goto xx352;
	if(yych != 'u') goto xx93;
xx352:
	yych = *++YYCURSOR;
	if(yych == 'M') goto xx353;
	if(yych != 'm') goto xx93;
xx353:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx354;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx354;
			if(yych <= 'z') goto xx92;
		}
	}
xx354:
#line 214 "./mql.re"
	{ TOKEN_RETURN("vacuum", T_KEY_VACUUM); }
#line 2549 "./mql_lexer.cpp"
xx355:
	yych = *++YYCURSOR;
	if(yych == '_') goto xx391;
	goto xx93;
xx356:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= 'D') {
			if(yych <= '9') {
				if(yych >= '0') goto xx92;
			} else {
				if(yych <= '@') goto xx357;
				if(yych <= 'C') goto xx92;
				goto xx360;
			}
		} else {
			if(yych <= 'R') {
				if(yych == 'I') goto xx359;
				goto xx92;
			} else {
				if(yych <= 'S') goto xx358;
				if(yych <= 'T') goto xx361;
				goto xx92;
			}
		}
	} else {
		if(yych <= 'h') {
			if(yych <= '`') {
				if(yych == '_') goto xx92;
			} else {
				if(yych == 'd') goto xx360;
				goto xx92;
			}
		} else {
			if(yych <= 's') {
				if(yych <= 'i') goto xx359;
				if(yych <= 'r') goto xx92;
				goto xx358;
			} else {
				if(yych <= 't') goto xx361;
				if(yych <= 'z') goto xx92;
			}
		}
	}
xx357:
#line 226 "./mql.re"
	{ TOKEN_RETURN("in", T_KEY_IN);  }
#line 2597 "./mql_lexer.cpp"
xx358:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx387;
	if(yych == 'e') goto xx387;
	goto xx93;
xx359:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx379;
	if(yych == 't') goto xx379;
	goto xx93;
xx360:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx373;
	if(yych == 'e') goto xx373;
	goto xx93;
xx361:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx362;
	if(yych != 'e') goto xx93;
xx362:
	yych = *++YYCURSOR;
	if(yych <= 'R') {
		if(yych == 'G') goto xx363;
		if(yych <= 'Q') goto xx93;
		goto xx364;
	} else {
		if(yych <= 'g') {
			if(yych <= 'f') goto xx93;
		} else {
			if(yych == 'r') goto xx364;
			goto xx93;
		}
	}
xx363:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx370;
	if(yych == 'e') goto xx370;
	goto xx93;
xx364:
	yych = *++YYCURSOR;
	if(yych == 'S') goto xx365;
	if(yych != 's') goto xx93;
xx365:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx366;
	if(yych != 'e') goto xx93;
xx366:
	yych = *++YYCURSOR;
	if(yych == 'C') goto xx367;
	if(yych != 'c') goto xx93;
xx367:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx368;
	if(yych != 't') goto xx93;
xx368:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx369;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx369;
			if(yych <= 'z') goto xx92;
		}
	}
xx369:
#line 291 "./mql.re"
	{ TOKEN_RETURN("intersect", T_KEY_INTERSECT); }
#line 2669 "./mql_lexer.cpp"
xx370:
	yych = *++YYCURSOR;
	if(yych == 'R') goto xx371;
	if(yych != 'r') goto xx93;
xx371:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx372;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx372;
			if(yych <= 'z') goto xx92;
		}
	}
xx372:
#line 229 "./mql.re"
	{ TOKEN_RETURN("integer", T_KEY_INTEGER);  }
#line 2691 "./mql_lexer.cpp"
xx373:
	yych = *++YYCURSOR;
	if(yych == 'X') goto xx374;
	if(yych != 'x') goto xx93;
xx374:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx375;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'E') goto xx376;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 'e') goto xx376;
			if(yych <= 'z') goto xx92;
		}
	}
xx375:
#line 228 "./mql.re"
	{ TOKEN_RETURN("index", T_KEY_INDEX); }
#line 2717 "./mql_lexer.cpp"
xx376:
	yych = *++YYCURSOR;
	if(yych == 'S') goto xx377;
	if(yych != 's') goto xx93;
xx377:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx378;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx378;
			if(yych <= 'z') goto xx92;
		}
	}
xx378:
#line 227 "./mql.re"
	{ TOKEN_RETURN("indexes", T_KEY_INDEXES); }
#line 2739 "./mql_lexer.cpp"
xx379:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx380;
	if(yych != 'i') goto xx93;
xx380:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx381;
	if(yych != 'a') goto xx93;
xx381:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx382;
	if(yych != 'l') goto xx93;
xx382:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx383;
	if(yych != 'i') goto xx93;
xx383:
	yych = *++YYCURSOR;
	if(yych == 'Z') goto xx384;
	if(yych != 'z') goto xx93;
xx384:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx385;
	if(yych != 'e') goto xx93;
xx385:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx386;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx386;
			if(yych <= 'z') goto xx92;
		}
	}
xx386:
#line 213 "./mql.re"
	{ TOKEN_RETURN("initialize", T_KEY_INITIALIZE);  }
#line 2781 "./mql_lexer.cpp"
xx387:
	yych = *++YYCURSOR;
	if(yych == 'R') goto xx388;
	if(yych != 'r') goto xx93;
xx388:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx389;
	if(yych != 't') goto xx93;
xx389:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx390;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx390;
			if(yych <= 'z') goto xx92;
		}
	}
xx390:
#line 209 "./mql.re"
	{ TOKEN_RETURN("insert", T_KEY_INSERT);  }
#line 2807 "./mql_lexer.cpp"
xx391:
	yych = *++YYCURSOR;
	if(yych == 'D') goto xx392;
	if(yych != 'd') goto xx93;
xx392:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx393;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'S') goto xx394;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 's') goto xx394;
			if(yych <= 'z') goto xx92;
		}
	}
xx393:
#line 232 "./mql.re"
	{ TOKEN_RETURN("id_d", T_KEY_ID_D);  }
#line 2833 "./mql_lexer.cpp"
xx394:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx395;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx395;
			if(yych <= 'z') goto xx92;
		}
	}
xx395:
#line 233 "./mql.re"
	{ TOKEN_RETURN("id_ds", T_KEY_ID_DS);  }
#line 2851 "./mql_lexer.cpp"
xx396:
	yych = *++YYCURSOR;
	if(yych == 'P') goto xx402;
	if(yych == 'p') goto xx402;
	goto xx93;
xx397:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx400;
	if(yych == 't') goto xx400;
	goto xx93;
xx398:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx399;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx399;
			if(yych <= 'z') goto xx92;
		}
	}
xx399:
#line 277 "./mql.re"
	{ TOKEN_RETURN("go", T_KEY_GO); }
#line 2879 "./mql_lexer.cpp"
xx400:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx401;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx401;
			if(yych <= 'z') goto xx92;
		}
	}
xx401:
#line 208 "./mql.re"
	{ TOKEN_RETURN("get", T_KEY_GET);  }
#line 2897 "./mql_lexer.cpp"
xx402:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '@') {
		if(yych <= '9') {
			if(yych >= '0') goto xx92;
		} else {
			if(yych == '?') goto xx404;
		}
	} else {
		if(yych <= '_') {
			if(yych <= 'Z') goto xx92;
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx403;
			if(yych <= 'z') goto xx92;
		}
	}
xx403:
#line 271 "./mql.re"
	{ TOKEN_RETURN("gap", T_KEY_GAP);  }
#line 2918 "./mql_lexer.cpp"
xx404:
	++YYCURSOR;
#line 272 "./mql.re"
	{ TOKEN_RETURN("gap?", T_KEY_OPT_GAP);  }
#line 2923 "./mql_lexer.cpp"
xx406:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx433;
	if(yych == 't') goto xx433;
	goto xx93;
xx407:
	yych = *++YYCURSOR;
	if(yych <= 'L') {
		if(yych == 'F') goto xx423;
		if(yych <= 'K') goto xx93;
		goto xx422;
	} else {
		if(yych <= 'f') {
			if(yych <= 'e') goto xx93;
			goto xx423;
		} else {
			if(yych == 'l') goto xx422;
			goto xx93;
		}
	}
xx408:
	yych = *++YYCURSOR;
	if(yych == 'F') goto xx413;
	if(yych == 'f') goto xx413;
	goto xx93;
xx409:
	yych = *++YYCURSOR;
	if(yych == 'O') goto xx410;
	if(yych != 'o') goto xx93;
xx410:
	yych = *++YYCURSOR;
	if(yych == 'P') goto xx411;
	if(yych != 'p') goto xx93;
xx411:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx412;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx412;
			if(yych <= 'z') goto xx92;
		}
	}
xx412:
#line 207 "./mql.re"
	{ TOKEN_RETURN("drop", T_KEY_DROP);  }
#line 2974 "./mql_lexer.cpp"
xx413:
	yych = *++YYCURSOR;
	if(yych == 'F') goto xx414;
	if(yych != 'f') goto xx93;
xx414:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx415;
	if(yych != 'e') goto xx93;
xx415:
	yych = *++YYCURSOR;
	if(yych == 'R') goto xx416;
	if(yych != 'r') goto xx93;
xx416:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx417;
	if(yych != 'e') goto xx93;
xx417:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx418;
	if(yych != 'n') goto xx93;
xx418:
	yych = *++YYCURSOR;
	if(yych == 'C') goto xx419;
	if(yych != 'c') goto xx93;
xx419:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx420;
	if(yych != 'e') goto xx93;
xx420:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx421;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx421;
			if(yych <= 'z') goto xx92;
		}
	}
xx421:
#line 292 "./mql.re"
	{ TOKEN_RETURN("difference", T_KEY_DIFFERENCE); }
#line 3020 "./mql_lexer.cpp"
xx422:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx429;
	if(yych == 'e') goto xx429;
	goto xx93;
xx423:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx424;
	if(yych != 'a') goto xx93;
xx424:
	yych = *++YYCURSOR;
	if(yych == 'U') goto xx425;
	if(yych != 'u') goto xx93;
xx425:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx426;
	if(yych != 'l') goto xx93;
xx426:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx427;
	if(yych != 't') goto xx93;
xx427:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx428;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx428;
			if(yych <= 'z') goto xx92;
		}
	}
xx428:
#line 234 "./mql.re"
	{ TOKEN_RETURN("default", T_KEY_DEFAULT);  }
#line 3059 "./mql_lexer.cpp"
xx429:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx430;
	if(yych != 't') goto xx93;
xx430:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx431;
	if(yych != 'e') goto xx93;
xx431:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx432;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx432;
			if(yych <= 'z') goto xx92;
		}
	}
xx432:
#line 210 "./mql.re"
	{ TOKEN_RETURN("delete", T_KEY_DELETE);  }
#line 3085 "./mql_lexer.cpp"
xx433:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx434;
	if(yych != 'a') goto xx93;
xx434:
	yych = *++YYCURSOR;
	if(yych == 'B') goto xx435;
	if(yych != 'b') goto xx93;
xx435:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx436;
	if(yych != 'a') goto xx93;
xx436:
	yych = *++YYCURSOR;
	if(yych == 'S') goto xx437;
	if(yych != 's') goto xx93;
xx437:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx438;
	if(yych != 'e') goto xx93;
xx438:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx439;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx439;
			if(yych <= 'z') goto xx92;
		}
	}
xx439:
#line 211 "./mql.re"
	{ TOKEN_RETURN("database", T_KEY_DATABASE);  }
#line 3123 "./mql_lexer.cpp"
xx440:
	yych = *++YYCURSOR;
	if(yych <= 'T') {
		if(yych <= 'K') {
			if(yych == 'G') goto xx459;
			goto xx93;
		} else {
			if(yych <= 'L') goto xx458;
			if(yych <= 'S') goto xx93;
			goto xx460;
		}
	} else {
		if(yych <= 'k') {
			if(yych == 'g') goto xx459;
			goto xx93;
		} else {
			if(yych <= 'l') goto xx458;
			if(yych == 't') goto xx460;
			goto xx93;
		}
	}
xx441:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx454;
	if(yych == 'e') goto xx454;
	goto xx93;
xx442:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx449;
	if(yych == 'n') goto xx449;
	goto xx93;
xx443:
	yych = *++YYCURSOR;
	if(yych == 'R') goto xx444;
	if(yych != 'r') goto xx93;
xx444:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx445;
	if(yych != 'i') goto xx93;
xx445:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx446;
	if(yych != 'n') goto xx93;
xx446:
	yych = *++YYCURSOR;
	if(yych == 'G') goto xx447;
	if(yych != 'g') goto xx93;
xx447:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx448;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx448;
			if(yych <= 'z') goto xx92;
		}
	}
xx448:
#line 230 "./mql.re"
	{ TOKEN_RETURN("string", T_KEY_STRING);  }
#line 3188 "./mql_lexer.cpp"
xx449:
	yych = *++YYCURSOR;
	if(yych == 'G') goto xx450;
	if(yych != 'g') goto xx93;
xx450:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx451;
	if(yych != 'l') goto xx93;
xx451:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx452;
	if(yych != 'e') goto xx93;
xx452:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx453;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx453;
			if(yych <= 'z') goto xx92;
		}
	}
xx453:
#line 246 "./mql.re"
	{ TOKEN_RETURN("single", T_KEY_SINGLE); }
#line 3218 "./mql_lexer.cpp"
xx454:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx455;
	if(yych != 'a') goto xx93;
xx455:
	yych = *++YYCURSOR;
	if(yych == 'F') goto xx456;
	if(yych != 'f') goto xx93;
xx456:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx457;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx457;
			if(yych <= 'z') goto xx92;
		}
	}
xx457:
#line 285 "./mql.re"
	{ TOKEN_RETURN("sheaf", T_KEY_SHEAF); }
#line 3244 "./mql_lexer.cpp"
xx458:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx469;
	if(yych == 'e') goto xx469;
	goto xx93;
xx459:
	yych = *++YYCURSOR;
	if(yych == 'M') goto xx464;
	if(yych == 'm') goto xx464;
	goto xx93;
xx460:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '@') {
			if(yych <= '/') goto xx461;
			if(yych <= '9') goto xx92;
		} else {
			if(yych == 'S') goto xx462;
			goto xx92;
		}
	} else {
		if(yych <= '`') {
			if(yych == '_') goto xx92;
		} else {
			if(yych == 's') goto xx462;
			if(yych <= 'z') goto xx92;
		}
	}
xx461:
#line 288 "./mql.re"
	{ TOKEN_RETURN("set", T_KEY_SET); }
#line 3276 "./mql_lexer.cpp"
xx462:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx463;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx463;
			if(yych <= 'z') goto xx92;
		}
	}
xx463:
#line 289 "./mql.re"
	{ TOKEN_RETURN("sets", T_KEY_SETS); }
#line 3294 "./mql_lexer.cpp"
xx464:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx465;
	if(yych != 'e') goto xx93;
xx465:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx466;
	if(yych != 'n') goto xx93;
xx466:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx467;
	if(yych != 't') goto xx93;
xx467:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx468;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx468;
			if(yych <= 'z') goto xx92;
		}
	}
xx468:
#line 244 "./mql.re"
	{ TOKEN_RETURN("segment", T_KEY_SEGMENT);  }
#line 3324 "./mql_lexer.cpp"
xx469:
	yych = *++YYCURSOR;
	if(yych == 'C') goto xx470;
	if(yych != 'c') goto xx93;
xx470:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx471;
	if(yych != 't') goto xx93;
xx471:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx472;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx472;
			if(yych <= 'z') goto xx92;
		}
	}
xx472:
#line 206 "./mql.re"
	{ TOKEN_RETURN("select", T_KEY_SELECT);  }
#line 3350 "./mql_lexer.cpp"
xx473:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx487;
	if(yych == 'i') goto xx487;
	goto xx93;
xx474:
	yych = *++YYCURSOR;
	if(yych == 'D') goto xx482;
	if(yych == 'd') goto xx482;
	goto xx93;
xx475:
	yych = *++YYCURSOR;
	if(yych <= 'I') {
		if(yych == 'E') goto xx476;
		if(yych <= 'H') goto xx93;
		goto xx478;
	} else {
		if(yych <= 'e') {
			if(yych <= 'd') goto xx93;
		} else {
			if(yych == 'i') goto xx478;
			goto xx93;
		}
	}
xx476:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx477;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx477;
			if(yych <= 'z') goto xx92;
		}
	}
xx477:
#line 212 "./mql.re"
	{ TOKEN_RETURN("use", T_KEY_USE);  }
#line 3392 "./mql_lexer.cpp"
xx478:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx479;
	if(yych != 'n') goto xx93;
xx479:
	yych = *++YYCURSOR;
	if(yych == 'G') goto xx480;
	if(yych != 'g') goto xx93;
xx480:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx481;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx481;
			if(yych <= 'z') goto xx92;
		}
	}
xx481:
#line 258 "./mql.re"
	{ TOKEN_RETURN("using", T_KEY_USING);  }
#line 3418 "./mql_lexer.cpp"
xx482:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx483;
	if(yych != 'a') goto xx93;
xx483:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx484;
	if(yych != 't') goto xx93;
xx484:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx485;
	if(yych != 'e') goto xx93;
xx485:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx486;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx486;
			if(yych <= 'z') goto xx92;
		}
	}
xx486:
#line 205 "./mql.re"
	{ TOKEN_RETURN("update", T_KEY_UPDATE); }
#line 3448 "./mql_lexer.cpp"
xx487:
	yych = *++YYCURSOR;
	if(yych <= 'Q') {
		if(yych == 'O') goto xx488;
		if(yych <= 'P') goto xx93;
		goto xx489;
	} else {
		if(yych <= 'o') {
			if(yych <= 'n') goto xx93;
		} else {
			if(yych == 'q') goto xx489;
			goto xx93;
		}
	}
xx488:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx493;
	if(yych == 'n') goto xx493;
	goto xx93;
xx489:
	yych = *++YYCURSOR;
	if(yych == 'U') goto xx490;
	if(yych != 'u') goto xx93;
xx490:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx491;
	if(yych != 'e') goto xx93;
xx491:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx492;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx492;
			if(yych <= 'z') goto xx92;
		}
	}
xx492:
#line 257 "./mql.re"
	{ TOKEN_RETURN("unique", T_KEY_UNIQUE);  }
#line 3493 "./mql_lexer.cpp"
xx493:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx494;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx494;
			if(yych <= 'z') goto xx92;
		}
	}
xx494:
#line 290 "./mql.re"
	{ TOKEN_RETURN("union", T_KEY_UNION); }
#line 3511 "./mql_lexer.cpp"
xx495:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx522;
	if(yych == 'l') goto xx522;
	goto xx93;
xx496:
	yych = *++YYCURSOR;
	if(yych <= 'N') {
		if(yych <= 'L') goto xx93;
		if(yych <= 'M') goto xx503;
		goto xx504;
	} else {
		if(yych <= 'l') goto xx93;
		if(yych <= 'm') goto xx503;
		if(yych <= 'n') goto xx504;
		goto xx93;
	}
xx497:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx498;
	if(yych != 'e') goto xx93;
xx498:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx499;
	if(yych != 'a') goto xx93;
xx499:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx500;
	if(yych != 't') goto xx93;
xx500:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx501;
	if(yych != 'e') goto xx93;
xx501:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx502;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx502;
			if(yych <= 'z') goto xx92;
		}
	}
xx502:
#line 204 "./mql.re"
	{ TOKEN_RETURN("create", T_KEY_CREATE); }
#line 3562 "./mql_lexer.cpp"
xx503:
	yych = *++YYCURSOR;
	if(yych <= 'P') {
		if(yych == 'M') goto xx512;
		if(yych <= 'O') goto xx93;
		goto xx513;
	} else {
		if(yych <= 'm') {
			if(yych <= 'l') goto xx93;
			goto xx512;
		} else {
			if(yych == 'p') goto xx513;
			goto xx93;
		}
	}
xx504:
	yych = *++YYCURSOR;
	if(yych == 'S') goto xx505;
	if(yych != 's') goto xx93;
xx505:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx506;
	if(yych != 't') goto xx93;
xx506:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx507;
	if(yych != 'a') goto xx93;
xx507:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx508;
	if(yych != 'n') goto xx93;
xx508:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx509;
	if(yych != 't') goto xx93;
xx509:
	yych = *++YYCURSOR;
	if(yych == 'S') goto xx510;
	if(yych != 's') goto xx93;
xx510:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx511;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx511;
			if(yych <= 'z') goto xx92;
		}
	}
xx511:
#line 243 "./mql.re"
	{ TOKEN_RETURN("constants", T_KEY_CONSTANTS);  }
#line 3619 "./mql_lexer.cpp"
xx512:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx519;
	if(yych == 'i') goto xx519;
	goto xx93;
xx513:
	yych = *++YYCURSOR;
	if(yych == 'U') goto xx514;
	if(yych != 'u') goto xx93;
xx514:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx515;
	if(yych != 't') goto xx93;
xx515:
	yych = *++YYCURSOR;
	if(yych == 'E') goto xx516;
	if(yych != 'e') goto xx93;
xx516:
	yych = *++YYCURSOR;
	if(yych == 'D') goto xx517;
	if(yych != 'd') goto xx93;
xx517:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx518;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx518;
			if(yych <= 'z') goto xx92;
		}
	}
xx518:
#line 235 "./mql.re"
	{ TOKEN_RETURN("computed", T_KEY_COMPUTED);  }
#line 3658 "./mql_lexer.cpp"
xx519:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx520;
	if(yych != 't') goto xx93;
xx520:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx521;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx521;
			if(yych <= 'z') goto xx92;
		}
	}
xx521:
#line 217 "./mql.re"
	{ TOKEN_RETURN("commit", T_KEY_COMMIT); }
#line 3680 "./mql_lexer.cpp"
xx522:
	yych = *++YYCURSOR;
	if(yych == 'C') goto xx523;
	if(yych != 'c') goto xx93;
xx523:
	yych = *++YYCURSOR;
	if(yych == 'U') goto xx524;
	if(yych != 'u') goto xx93;
xx524:
	yych = *++YYCURSOR;
	if(yych == 'L') goto xx525;
	if(yych != 'l') goto xx93;
xx525:
	yych = *++YYCURSOR;
	if(yych == 'A') goto xx526;
	if(yych != 'a') goto xx93;
xx526:
	yych = *++YYCURSOR;
	if(yych == 'T') goto xx527;
	if(yych != 't') goto xx93;
xx527:
	yych = *++YYCURSOR;
	if(yych == 'I') goto xx528;
	if(yych != 'i') goto xx93;
xx528:
	yych = *++YYCURSOR;
	if(yych == 'O') goto xx529;
	if(yych != 'o') goto xx93;
xx529:
	yych = *++YYCURSOR;
	if(yych == 'N') goto xx530;
	if(yych != 'n') goto xx93;
xx530:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'Z') {
		if(yych <= '/') goto xx531;
		if(yych <= '9') goto xx92;
		if(yych >= 'A') goto xx92;
	} else {
		if(yych <= '_') {
			if(yych >= '_') goto xx92;
		} else {
			if(yych <= '`') goto xx531;
			if(yych <= 'z') goto xx92;
		}
	}
xx531:
#line 279 "./mql.re"
	{ TOKEN_RETURN("calculation", T_KEY_CALCULATION); }
#line 3730 "./mql_lexer.cpp"
}
#line 339 "./mql.re"


stringdq:
	tok = cur;

#line 3738 "./mql_lexer.cpp"
{
	YYCTYPE yych;
	yych = *YYCURSOR;
	if(yych <= '!') {
		if(yych <= 0x00) goto xx538;
		if(yych == 0x0A) goto xx541;
		goto xx540;
	} else {
		if(yych <= '"') goto xx534;
		if(yych == '\\') goto xx536;
		goto xx540;
	}
xx534:
	++YYCURSOR;
#line 344 "./mql.re"
	{ TOKEN_RETURN("string", T_STRING); }
#line 3755 "./mql_lexer.cpp"
xx536:
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'b') {
		if(yych <= '3') {
			if(yych <= '&') {
				if(yych == '"') goto xx546;
			} else {
				if(yych <= '\'') goto xx548;
				if(yych >= '0') goto xx545;
			}
		} else {
			if(yych <= '[') {
				if(yych == '?') goto xx550;
			} else {
				if(yych <= '\\') goto xx552;
				if(yych <= '`') goto xx537;
				if(yych <= 'a') goto xx558;
				goto xx560;
			}
		}
	} else {
		if(yych <= 'r') {
			if(yych <= 'm') {
				if(yych == 'f') goto xx554;
			} else {
				if(yych <= 'n') goto xx566;
				if(yych >= 'r') goto xx556;
			}
		} else {
			if(yych <= 'u') {
				if(yych == 't') goto xx564;
			} else {
				if(yych <= 'v') goto xx562;
				if(yych == 'x') goto xx543;
			}
		}
	}
xx537:
#line 368 "./mql.re"
	{ yylval->pString->append(1, *tok);
			       goto stringdq; }
#line 3797 "./mql_lexer.cpp"
xx538:
	++YYCURSOR;
#line 367 "./mql.re"
	{ if (cur >= lim) { goto end; } }
#line 3802 "./mql_lexer.cpp"
xx540:
	yych = *++YYCURSOR;
	goto xx537;
xx541:
	++YYCURSOR;
#line 370 "./mql.re"
	{ yylval->pString->append(1, '\n');
			       goto stringdq; }
#line 3811 "./mql_lexer.cpp"
xx543:
	yych = *++YYCURSOR;
	if(yych <= '@') {
		if(yych <= '/') goto xx544;
		if(yych <= '9') goto xx571;
	} else {
		if(yych <= 'F') goto xx571;
		if(yych <= '`') goto xx544;
		if(yych <= 'f') goto xx571;
	}
xx544:
	YYCURSOR = YYMARKER;
	goto xx537;
xx545:
	yych = *++YYCURSOR;
	if(yych <= '/') goto xx544;
	if(yych <= '7') goto xx568;
	goto xx544;
xx546:
	++YYCURSOR;
#line 355 "./mql.re"
	{ yylval->pString->append(1, '\"'); goto stringdq; }
#line 3834 "./mql_lexer.cpp"
xx548:
	++YYCURSOR;
#line 354 "./mql.re"
	{ yylval->pString->append(1, '\''); goto stringdq; }
#line 3839 "./mql_lexer.cpp"
xx550:
	++YYCURSOR;
#line 353 "./mql.re"
	{ yylval->pString->append(1, '\?'); goto stringdq; }
#line 3844 "./mql_lexer.cpp"
xx552:
	++YYCURSOR;
#line 352 "./mql.re"
	{ yylval->pString->append(1, '\\'); goto stringdq; }
#line 3849 "./mql_lexer.cpp"
xx554:
	++YYCURSOR;
#line 351 "./mql.re"
	{ yylval->pString->append(1, '\f'); goto stringdq; }
#line 3854 "./mql_lexer.cpp"
xx556:
	++YYCURSOR;
#line 350 "./mql.re"
	{ yylval->pString->append(1, '\r'); goto stringdq; }
#line 3859 "./mql_lexer.cpp"
xx558:
	++YYCURSOR;
#line 349 "./mql.re"
	{ yylval->pString->append(1, '\a'); goto stringdq; }
#line 3864 "./mql_lexer.cpp"
xx560:
	++YYCURSOR;
#line 348 "./mql.re"
	{ yylval->pString->append(1, '\b'); goto stringdq; }
#line 3869 "./mql_lexer.cpp"
xx562:
	++YYCURSOR;
#line 347 "./mql.re"
	{ yylval->pString->append(1, '\v'); goto stringdq; }
#line 3874 "./mql_lexer.cpp"
xx564:
	++YYCURSOR;
#line 346 "./mql.re"
	{ yylval->pString->append(1, '\t'); goto stringdq; }
#line 3879 "./mql_lexer.cpp"
xx566:
	++YYCURSOR;
#line 345 "./mql.re"
	{ yylval->pString->append(1, '\n'); goto stringdq; }
#line 3884 "./mql_lexer.cpp"
xx568:
	yych = *++YYCURSOR;
	if(yych <= '/') goto xx544;
	if(yych >= '8') goto xx544;
	++YYCURSOR;
#line 356 "./mql.re"
	{ tok += 1; // Go past SLASH 
		    std::string mystr;
		    getString(mystr);
		    yylval->pString->append(1, octal2char(mystr.c_str())); 
		    goto stringdq; }
#line 3896 "./mql_lexer.cpp"
xx571:
	yych = *++YYCURSOR;
	if(yych <= '@') {
		if(yych <= '/') goto xx544;
		if(yych >= ':') goto xx544;
	} else {
		if(yych <= 'F') goto xx572;
		if(yych <= '`') goto xx544;
		if(yych >= 'g') goto xx544;
	}
xx572:
	++YYCURSOR;
#line 361 "./mql.re"
	{ tok += 2; // Go past SLASH x
			       std::string mystr;
			       getString(mystr);
			       yylval->pString->append(1, hex2char(mystr.c_str()));
			       goto stringdq; 			     
                             }
#line 3916 "./mql_lexer.cpp"
}
#line 372 "./mql.re"


stringsq:
	tok = cur;

#line 3924 "./mql_lexer.cpp"
{
	YYCTYPE yych;
	yych = *YYCURSOR;
	if(yych <= 0x0A) {
		if(yych <= 0x00) goto xx578;
		if(yych <= 0x09) goto xx582;
		goto xx580;
	} else {
		if(yych != '\'') goto xx582;
	}
	++YYCURSOR;
#line 377 "./mql.re"
	{ TOKEN_RETURN("string", T_STRING); }
#line 3938 "./mql_lexer.cpp"
xx578:
	++YYCURSOR;
#line 378 "./mql.re"
	{ if (cur >= lim) { goto end; } }
#line 3943 "./mql_lexer.cpp"
xx580:
	++YYCURSOR;
#line 379 "./mql.re"
	{ yylval->pString->append(1, '\n');
			       goto stringsq; }
#line 3949 "./mql_lexer.cpp"
xx582:
	++YYCURSOR;
#line 381 "./mql.re"
	{ yylval->pString->append(1, *tok);
			       goto stringsq; }
#line 3955 "./mql_lexer.cpp"
}
#line 383 "./mql.re"

	
 end:
	return 0;
}


void MQLScanner::addToken(void)
{
	yylval->setString(new std::string);
	const char *p;
	for (p = tok;
	     p != cur;
	     ++p) {
	     yylval->pString->append(1, *p);
	}
}

void MQLScanner::addInteger(void)
{
	const unsigned int MAX_INTEGER_CHARS = 12;
	unsigned int cnt = cur - tok;
	if (cnt > MAX_INTEGER_CHARS) {
	   	std::string mystring;
		const char *p;
		for (p = tok;
		     p != cur;
	     	     ++p) {
		     mystring.append(1, *p);
		}
		yylval->setInteger(strtol(mystring.c_str(), (char **)NULL, 10));
        } else {
		char szInt[MAX_INTEGER_CHARS+1];

		const char *p;
		char *q = szInt;
		for (p = tok;
		     p != cur;
	     	     ++p) {
		     *q++ = *p;
		}
		*q = '\0';
		yylval->setInteger(strtol(szInt, (char **)NULL, 10));
	}
}

void MQLScanner::getString(std::string& str)
{
	const char *p;
	for (p = tok;
	     p != cur;
	     ++p) {
	     str.append(1, *p);
	}
}

