/* Generated by re2c 0.12.3 on Sat Aug 15 14:16:48 2009 */
#line 1 "pennlexer.re"
/*
 * pennlexer.lxx
 *
 * Penn Treebank lexer
 *
 * Ulrik Petersen
 * Created: 2/17-2006
 * Last update: 6/23-2007
 *
 */
/************************************************************************
 *
 *   Emdros - the database engine for analyzed or annotated text
 *   Copyright (C) 2006-2007  Ulrik Petersen
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation, license version 2.  
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *   02111-1307 USA
 *
 *
 *   Special exception
 *   =================
 * 
 *   In addition, as a special exception, Ulrik Petersen, the
 *   copyright holder of Emdros, gives permission to link Emdros, in
 *   whole or in part, with the libraries which are normally
 *   distributed with:
 *   
 *   a) Sun's Java platform,
 *   b) Python, 
 *   c) Jython,
 *   d) Ruby, and/or 
 *   e) Perl 
 *   f) PostgreSQL
 *   g) OpenSSL
 *
 *   (or with modified versions of these), and to distribute linked
 *   combinations including both Emdros, in whole or in part, and one
 *   or more of the libraries normally distributed with (a)-(g) above.
 *
 *   Please note: This gives you special rights concerning the
 *   libraries which normally accompany the above pieces of software.
 *   It gives you no special rights concerning software that you write
 *   yourself.  You must obey the GNU General Public License in all
 *   respects for all of the code used other than the libraries
 *   normally distributed with (a)-(g) above.
 *
 *   If you modify this file, you may extend this exception to your
 *   version of the file, but you are not obligated to do so. If you
 *   do not wish to do so, delete this exception statement from your
 *   version.
 *
 *
 *   Other licensing forms
 *   =====================
 *
 *   If you wish to negotiate commercial licensing, please contact
 *   Ulrik Petersen at ulrikp[at]users.sourceforge.net.
 *
 *   Licensing can also be negotiated if your organization is an
 *   educational, non-profit, charity, missionary or similar
 *   organization.
 *
 *
 *   Website
 *   =======
 *
 *   Emdros has a website here:
 *
 *   http://emdros.org
 *
 *
 *
 **************************************************************************/



#include <cstring>
#include <string>
#include <sstream>
#include <pennimporter.h>
#include "pennparser.h"

#define TOKEN_RETURN(X,Y) { yylval->setName(X); return Y; }

#define YYMAXFILL 4


#define BSIZE 8192
#if YYMAXFILL > BSIZE
#error YYMAXFILL must be less than or equal to BSIZE!
#endif

#define YYCTYPE         unsigned char
#define YYCURSOR        cur
#define YYLIMIT         lim
#define YYMARKER        ptr
#define YYFILL(n)       {cur = fill(cur);}

#line 115 "pennlexer.re"


PennScanner::PennScanner(std::istream *pIstr)
{
	pIn = pIstr;
	bot = tok = ptr = cur = pos = lim = top = eof = 0;
}

PennScanner::~PennScanner()
{
	if (bot) {
		delete[] bot;
	}
}

void PennScanner::addToken(void)
{
	yylval->setString(new std::string);
	const unsigned char *p;
	for (p = tok;
	     p != cur;
	     ++p) {
	     yylval->pString->append(1, *p);
	}
	//std::cerr << "UP202: addToken: '" << *(yylval->pString) << "'" << std::endl;
}

unsigned char *PennScanner::fill(unsigned char *cursor)
{
        if(!eof)
        {
                unsigned int cnt = tok - bot;
                if(cnt)
                {
                        memcpy(bot, tok, lim - tok);
                        tok = bot;
                        ptr -= cnt;
                        cursor -= cnt;
                        pos -= cnt;
                        lim -= cnt;
                }
                if((top - lim) < BSIZE)
                {
                        unsigned char *buf = new unsigned char[(lim - bot) + BSIZE];
                        memcpy(buf, tok, lim - tok);
                        tok = buf;
                        ptr = &buf[ptr - bot];
                        cursor = &buf[cursor - bot];
                        pos = &buf[pos - bot];
                        lim = &buf[lim - bot];
                        top = &lim[BSIZE];
                        delete [] bot;
                        bot = buf;
                }
                pIn->read((char *) lim, BSIZE);
                if ((cnt = pIn->gcount()) != BSIZE )
                {
                        eof = &lim[cnt]; *eof++ = '\0';
                }
                lim += cnt;
        }
        return cursor;
}


int PennScanner::scan(PennToken *pYYLVAL)
{
	yylval = pYYLVAL;
	

 scan:	
	tok = cur;


#line 187 "pennlexer.cpp"
{
	YYCTYPE yych;

	if((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if(yych <= 0x1F) {
		if(yych <= 0x0A) {
			if(yych <= 0x00) goto yy13;
			if(yych <= 0x08) goto yy7;
			goto yy4;
		} else {
			if(yych <= 0x0B) goto yy6;
			if(yych == 0x0D) goto yy4;
			goto yy7;
		}
	} else {
		if(yych <= '%') {
			if(yych <= ' ') goto yy4;
			if(yych <= '#') goto yy7;
			if(yych <= '$') goto yy8;
		} else {
			if(yych <= '\'') goto yy7;
			if(yych <= '(') goto yy9;
			if(yych <= ')') goto yy11;
			goto yy7;
		}
	}
	++YYCURSOR;
	if((yych = *YYCURSOR) == '%') goto yy22;
	goto yy17;
yy3:
#line 191 "pennlexer.re"
	{ addToken();
            TOKEN_RETURN("word/function", T_NAME);
          }
#line 223 "pennlexer.cpp"
yy4:
	++YYCURSOR;
yy5:
#line 190 "pennlexer.re"
	{ goto scan; }
#line 229 "pennlexer.cpp"
yy6:
	yych = *++YYCURSOR;
	if(yych <= 0x0D) {
		if(yych <= 0x08) {
			if(yych <= 0x00) goto yy5;
			goto yy16;
		} else {
			if(yych <= 0x0A) goto yy5;
			if(yych <= 0x0C) goto yy16;
			goto yy5;
		}
	} else {
		if(yych <= ' ') {
			if(yych <= 0x1F) goto yy16;
			goto yy5;
		} else {
			if(yych <= '\'') goto yy16;
			if(yych <= ')') goto yy5;
			goto yy16;
		}
	}
yy7:
	yych = *++YYCURSOR;
	goto yy17;
yy8:
	yych = *++YYCURSOR;
	if(yych == '(') goto yy15;
	goto yy17;
yy9:
	++YYCURSOR;
#line 194 "pennlexer.re"
	{ TOKEN_RETURN("LPAREN", T_KEY_LPAREN); }
#line 262 "pennlexer.cpp"
yy11:
	++YYCURSOR;
#line 195 "pennlexer.re"
	{ TOKEN_RETURN("RPAREN", T_KEY_RPAREN); }
#line 267 "pennlexer.cpp"
yy13:
	++YYCURSOR;
#line 196 "pennlexer.re"
	{ if (cur >= eof) { goto end; } }
#line 272 "pennlexer.cpp"
yy15:
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '-') goto yy18;
	goto yy3;
yy16:
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy17:
	if(yych <= 0x0D) {
		if(yych <= 0x08) {
			if(yych <= 0x00) goto yy3;
			goto yy16;
		} else {
			if(yych <= 0x0A) goto yy3;
			if(yych <= 0x0C) goto yy16;
			goto yy3;
		}
	} else {
		if(yych <= ' ') {
			if(yych <= 0x1F) goto yy16;
			goto yy3;
		} else {
			if(yych <= '\'') goto yy16;
			if(yych <= ')') goto yy3;
			goto yy16;
		}
	}
yy18:
	yych = *++YYCURSOR;
	if(yych <= 0x0D) {
		if(yych <= 0x08) {
			if(yych >= 0x01) goto yy20;
		} else {
			if(yych <= 0x0A) goto yy19;
			if(yych <= 0x0C) goto yy20;
		}
	} else {
		if(yych <= ' ') {
			if(yych <= 0x1F) goto yy20;
		} else {
			if(yych <= '\'') goto yy20;
			if(yych >= '*') goto yy20;
		}
	}
yy19:
	YYCURSOR = YYMARKER;
	goto yy3;
yy20:
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= 0x0D) {
		if(yych <= 0x08) {
			if(yych <= 0x00) goto yy3;
			goto yy20;
		} else {
			if(yych <= 0x0A) goto yy3;
			if(yych <= 0x0C) goto yy20;
			goto yy3;
		}
	} else {
		if(yych <= ' ') {
			if(yych <= 0x1F) goto yy20;
			goto yy3;
		} else {
			if(yych <= '\'') goto yy20;
			if(yych <= ')') goto yy3;
			goto yy20;
		}
	}
yy22:
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 0x0D) {
		if(yych <= 0x08) {
			if(yych >= 0x01) goto yy16;
		} else {
			if(yych <= 0x0A) goto yy23;
			if(yych <= 0x0C) goto yy16;
		}
	} else {
		if(yych <= ' ') {
			if(yych <= 0x1F) goto yy16;
		} else {
			if(yych <= '\'') goto yy16;
			if(yych >= '*') goto yy16;
		}
	}
yy23:
#line 189 "pennlexer.re"
	{ goto comment; }
#line 364 "pennlexer.cpp"
}
#line 198 "pennlexer.re"


 comment:

#line 371 "pennlexer.cpp"
{
	YYCTYPE yych;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= 0x00) goto yy28;
	if(yych != 0x0A) goto yy30;
	++YYCURSOR;
#line 202 "pennlexer.re"
	{ goto scan; }
#line 381 "pennlexer.cpp"
yy28:
	++YYCURSOR;
#line 203 "pennlexer.re"
	{ if (cur >= eof) { goto end; } }
#line 386 "pennlexer.cpp"
yy30:
	++YYCURSOR;
#line 204 "pennlexer.re"
	{ tok = cur; goto comment; }
#line 391 "pennlexer.cpp"
}
#line 205 "pennlexer.re"


 end:
 	return 0;
}
